<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 07.11.2005
 * 
 * This script shows the databas and path data dialogue.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 
 class DataView extends AdminView {
 	
 	var $check_mail;
 	
 	function DataView() {
 		global $config;
 		parent::AdminView();
 		$this->setTitle($this->lang_admin["dbdata_title"]);
 	}
 	
 	function display() {
 		if((isset($_POST["do"]) && $_POST["do"]=="save") && $this->checkInputfields()) {
 			if($this->saveData()) {
		    	$this->showSuccess($this->lang_admin["db_save_success"]);
		    	$this->my_smarty->display('success.tpl');
		    	exit;
		    } else
		      $this->showError($this->lang_admin["db_save_error"]);
		    	
		}
 		$this->showForm();
 		
 		$this->my_smarty->display('dbdata.tpl');
 	}
 	
 	function saveData() {
 		global $config;
 		$dataValid = @mysql_connect($_POST["db_host"],$_POST["db_user"],$_POST["db_user_pass"]);
 		if(!$dataValid)
 			return false;
		$dataValid = @mysql_select_db($_POST["db_name"]);
		if(!$dataValid)
		    return false;
		    
		$my_smarty2 = new MySmarty("../",TMPL_INSTALL);
		$my_smarty2->assign('db_host',$_POST["db_host"]);
		$my_smarty2->assign('db_user',$_POST["db_user"]);
		$my_smarty2->assign('db_pass',$_POST["db_user_pass"]);
		$my_smarty2->assign('db_name',$_POST["db_name"]);
		$my_smarty2->assign('prefix',$_POST["db_prefix"]);
		$my_smarty2->assign('proj_url',$config["proj_url"]);
		$my_smarty2->assign('proj_path',$config["proj_path"]);
	 	
	 	$temp_fp = fopen("../config.php", "w");
		fputs($temp_fp, $my_smarty2->fetch('config.tpl'));
		fclose($temp_fp);
		
		return true;
 	}
 	
 	function showForm() {
 		global $config;
 		
 		$this->my_smarty->assign('dbdata_title',$this->lang_admin["dbdata_title"]);
		$this->my_smarty->assign('php_self', $this->getScriptName());
		$this->my_smarty->assign('dbdata_tooltips',$this->lang_admin["dbdata_tooltips"]);
		$this->my_smarty->assign('db_host_label',$this->lang_admin["db_host_label"]);
		if(isset($_POST["db_host"]))
			$this->my_smarty->assign('db_host_value',$_POST["db_host"]);
		else $this->my_smarty->assign('db_host_value',$config["dbhost"]);
		$this->my_smarty->assign('db_user_label',$this->lang_admin["db_user_label"]);
		if(isset($_POST["db_user"]))
			$this->my_smarty->assign('db_user_value',$_POST["db_user"]);
		else $this->my_smarty->assign('db_user_value',$config["dbuser"]);
		$this->my_smarty->assign('db_user_pass_label',$this->lang_admin["db_user_pass_label"]);
		if(isset($_POST["db_user_pass"]))
			$this->my_smarty->assign('db_user_pass_value',$_POST["db_user_pass"]);
		else $this->my_smarty->assign('db_user_pass_value',$config["dbpass"]);
		$this->my_smarty->assign('db_name_label',$this->lang_admin["db_name_label"]);
		if(isset($_POST["db_name"]))
			$this->my_smarty->assign('db_name_value',$_POST["db_name"]);
		else $this->my_smarty->assign('db_name_value',$config["dbname"]);
		$this->my_smarty->assign('db_prefix_label',$this->lang_admin["db_prefix_label"]);
		if(isset($_POST["db_prefix"]))
			$this->my_smarty->assign('db_prefix_value',$_POST["db_prefix"]);
		else $this->my_smarty->assign('db_prefix_value',$config["db_prefix"]);
	    $this->my_smarty->assign('save_button',$this->lang_admin["save_button_label"]);
 	}
 	
 	function checkInputfields() {
	 	$missing_field = false;
	 	$req_fields = array(0 => 'db_host' ,1 => 'db_name');
	 	
	 	foreach($req_fields as $field) {
	 		if(!isset($_POST[$field]) || $_POST[$field]=="") {
	 		    $this->my_smarty->assign($field."_class","red_border");
	 		    $missing_field = true;
	 		}
	 	}
	 	
	 	if($missing_field) {
	 		$this->showError($this->lang_error["missing_input_fields"]);
	 		return false;
	 	}
	 	
	 	return true;
	}
	
	function getScriptName() {
		global $php_extension;
   	    return "dbdata.".$php_extension;
    }
 }
 
 $data_view = new DataView();
 $data_view->display();
?>
