<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 07.06.2005
 * 
 * This script shows the user administration dialogue and lets the admin 
 * delete users or change their ranks
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 
 class UserEdit extends AdminView {
 	
 	
 	function UserEdit() {
 		global $config;
 		parent::AdminView();
 	}
 	
 	function display() {
 		if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "save"){
 			$this->saveChanges();
 		}
 		
 		if(isset($_REQUEST["userID"])){
 			$userID = $_REQUEST["userID"];
 			if($this->user_manager->userIDExists($userID)){
 				$this->editUser($userID);
 			}
 		}
 		
 		$this->my_smarty->display('edit_user.tpl');
 	}
 	
 	function editUser($userID) {
 		global $php_extension;
 		$user = $this->user_manager->getUser($userID);
 		$this->my_smarty->assign("user_admin_title", $this->lang_admin["user_admin_title"]." [".$user["username"]."]");
 		$this->my_smarty->assign("user_overview_link", $this->lang_admin["user_overview_link"]);
 		$this->setTitle($this->lang_admin["user_admin_title"]." [".$user["username"]."]");
 		$this->my_smarty->assign("php_self", "edit_user.".$php_extension."?userID=$userID");
 		$ranks_available = $this->rank_manager->getAllRanks(true);
 		$this->my_smarty->assign("ranks_available", $ranks_available);
 		$this->my_smarty->assign("user_labels", $this->lang_admin["user_table_header"]);
 		$this->my_smarty->assign("user", $user);
 		$this->my_smarty->assign("user_submit_button", $this->lang_admin["user_submit_button"]);
 	}
 	
 	function saveChanges(){
 		if(isset($_REQUEST["rankID"])){
 			$rankID = $_REQUEST["rankID"];
 			$userID = $_REQUEST["userID"];
 			$update = $this->user_manager->updateRank($userID, $rankID);
 			if($update) {
 				$this->my_smarty->assign("success_title", $this->lang_admin["success_title"]);
 				$this->my_smarty->assign("success_message", $this->lang_admin["success_rank_changed"]);
 			}
 		}
 	}
 	
 }
 
 $user_edit = new UserEdit();
 $user_edit->display();
?>
