<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 07.06.2005
 * 
 * This script shows the change email data dialogue.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 require_once('../classes/CheckMail.class.php');
 require_once('../classes/FolderManager.class.php');
 
 class EmailView extends AdminView {
 	
 	var $check_mail;
 	
 	function EmailView() {
 		global $config;
 		parent::AdminView();
 		$this->setTitle($this->lang_admin["email_title"]);
 		$this->check_mail = new CheckMail($this->dbCon,$config);
 	}
 	
 	function display() {
 		 if(!isset($_POST["mail_tmpl_btn"]) && (isset($_POST["do"]) && $_POST["do"]=="save") && $this->checkInputfields()) {
 			if($this->saveEmailData($_POST["email_addr"],$_POST["email_srv"],$_POST["email_port"]
 												,$_POST["email_protocol"],$_POST["email_password"])) {
		    	$this->showSuccess($this->lang_admin["email_save_success"]);
		    	$this->my_smarty->display('success.tpl');
		    	exit;
		    } else
		      $this->showError($this->lang_admin["email_save_error"]);
		    	
		}
 		$this->showForm();
 		
 		$this->my_smarty->display('email.tpl');
 	}
 	
 	/**
     * Saves the email data to the database.
     */
    function saveEmailData($email,$server,$port,$protocol,$password) {
    	global $config;
    	$sql = "Delete from ".$config["db_prefix"]."item_email";
  		$delete = mysql_query($sql);
    	$sql = "INSERT INTO ".$config["db_prefix"]."item_email(email,server,port,protocol,password) " .
    			"VALUES('".$email."','".$server."','".$port."','".$protocol."','".$password."')";
    	$result = $this->dbCon->insertIntoDB($sql);
  		return $result;
    }
 	
 	function showForm() {
 		global $config;
 		$email_data = $this->check_mail->getEmailData();
 		
 		$mail_templates = array();
 		$folder_manager = new FolderManager();
	 	$folder_manager->listMailTemplates("../mods/email_tmpl",$mail_templates);
	 	$this->my_smarty->assign('mail_templates',$mail_templates);
	 	
		$this->my_smarty->assign('email_tmpl_label',$this->lang_admin["email_tmpl_label"]);
		$this->my_smarty->assign('choose_tmpl_button',$this->lang_admin["choose"]);
 	
 		$this->my_smarty->assign('email_title',$this->lang_admin["email_title"]);
		$this->my_smarty->assign('php_self', $this->getScriptName());
		$this->my_smarty->assign('email_tooltips',$this->lang_admin["email_tooltips"]);
		$this->my_smarty->assign('email_addr_label',$this->lang_admin["email_addr_label"]);
		if(isset($_POST["email_addr"]))
			$this->my_smarty->assign('email_addr_value',$_POST["email_addr"]);
	    else $this->my_smarty->assign('email_addr_value',$email_data["email"]);
		$this->my_smarty->assign('email_srv_label',$this->lang_admin["email_srv_label"]);
		if(isset($_POST["email_srv"]))
			$this->my_smarty->assign('email_srv_value',$_POST["email_srv"]);
	    else $this->my_smarty->assign('email_srv_value',$email_data["server"]);
		$this->my_smarty->assign('email_port_label',$this->lang_admin["email_port_label"]);
		if(isset($_POST["email_port"]))
			$this->my_smarty->assign('email_port_value',$_POST["email_port"]);
	    else $this->my_smarty->assign('email_port_value',$email_data["port"]);
		$this->my_smarty->assign('email_protocol_label',$this->lang_admin["email_protocol_label"]);
		if(isset($_POST["email_protocol"]))
			$this->my_smarty->assign('email_protocol_value',$_POST["email_protocol"]);
	    else $this->my_smarty->assign('email_protocol_value',$email_data["protocol"]);
		$this->my_smarty->assign('email_password_label',$this->lang_admin["email_password_label"]);
		if(isset($_POST["email_password"]))
			$this->my_smarty->assign('email_password_value',$_POST["email_password"]);
	    else $this->my_smarty->assign('email_password_value',$email_data["password"]);
	    $this->my_smarty->assign('save_button',$this->lang_admin["save_button_label"]);
	    
	    if(isset($_POST["mail_tmpl"])) {
 			include("../mods/email_tmpl/".$_POST["mail_tmpl"]);
 			$this->my_smarty->assign('email_srv_value',$mail_server);
 			$this->my_smarty->assign('email_port_value',$mail_port);
 			$this->my_smarty->assign('email_protocol_value',$mail_protocol);
 		}
 	}
 	
 	function checkInputfields() {
	 	$missing_field = false;
	 	$req_fields = array(0 => 'email_addr',1 => 'email_srv',2 => 'email_port',3 => 'email_protocol',4 => 'email_password');
	 	
	 	foreach($req_fields as $field) {
	 		if(!isset($_POST[$field]) || $_POST[$field]=="") {
	 		    $this->my_smarty->assign($field."_class","red_border");
	 		    $missing_field = true;
	 		}
	 	}
	 	
	 	if($missing_field) {
	 		$this->showError($this->lang_error["missing_input_fields"]);
	 		return false;
	 	}
	 	
	 	$mailboxAddress = "{".$_POST["email_srv"]."/".
    				          $_POST["email_protocol"].":".
    				          $_POST["email_port"]."}INBOX";
        $mailbox = @imap_open($mailboxAddress, $_POST["email_addr"], $_POST["email_password"]);
        if(!$mailbox) {
        	$server_message = imap_last_error();
        	$this->showError($this->lang_admin["email_data_error"]);
			return false;
        }
	 	
	 	return true;
	}
	
	function getScriptName() {
 		global $php_extension;
   	    return "email.".$php_extension;
    }
 }
 
 $email_view = new EmailView();
 $email_view->display();
?>
