<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 07.06.2005
 * 
 * This script shows the options dialogue and lets the admin change some values
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 require_once('../classes/FolderManager.class.php');
 require_once('../classes/CategoryManager.class.php');
 require_once('../classes/ItemManager.class.php');
 
 class OptionsView extends AdminView {
 	
 	var $folder_manager;
    var $cat_manager;
    var $item_manager;
 	
 	function OptionsView() {
 		global $config;
 		parent::AdminView();
 		$this->folder_manager = new FolderManager();
 		$this->cat_manager = new CategoryManager($this->dbCon,$config);
     	$this->item_manager = new ItemManager($this->dbCon,$config,$this->options);
     	
     	$this->setTitle($this->lang_admin["option_title"]);
 	}
 	
 	function display() {
 		if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "changedOptions"){
 			if($this->allFieldsFilled()) $this->saveOptions();
 			else $this->showError($this->lang_admin["all_fields_must_be_filled"]);
 		}
 		$this->my_smarty->assign("option_title", $this->lang_admin["option_title"]);
 		
 		$this->createDisplayOptions();
 		
 		$this->my_smarty->display('options.tpl');
 	}
 	
 	function saveOptions() {
 		global $config;
// 		echo "<br>config db-prefix = ".$config["db_prefix"];
// 		echo "<br>var html_allowed = ".$_REQUEST["html_allowed"]."<br>";
 		$sql = "Update ".$config["db_prefix"]."options set language = '".$_REQUEST["language"]."'," .
 				                                          "template = '".$_REQUEST["template"]."'," .
 				                                          "default_cat = ".$_REQUEST["default_cat"]."," .
 				                                          "date_format = '".$_REQUEST["date_format"]."'," .
 				                                          "split_item_date_format = '".$_REQUEST["split_date_format"]."'," .
 				                                          "media_formats_allowed = '".$_REQUEST["media_formats_allowed"]."',".
 				                                          "max_items_per_page = ".$_REQUEST["max_items_per_page"]."," .
 				                                          "max_media_size = ".$_REQUEST["max_media_size"]."," .
 				                                          "max_files = ".$_REQUEST["max_files"]."," .
 				                                          "html_allowed = ".$_REQUEST["html_allowed"]."," .
 				                                          "adjust_overview = ".$_REQUEST["adjust_overview"]."," .
 				                                          "comments_allowed = ".$_REQUEST["comments_allowed"]."," .
 				                                          "rating_allowed = ".$_REQUEST["rating_allowed"]."," .
 				                                          "registration_allowed = ".$_REQUEST["registration_allowed"]."," .
 				                                          "ranking_on = ".$_REQUEST["ranking_on"]."," .
 				                                          "seconds_to_recount = ".$_REQUEST["seconds_to_recount"]."," .
 				                                          "email_check_on = ".$_REQUEST["email_check_on"].",".
 				                                          "seconds_to_email_check = ".$_REQUEST["seconds_to_email_check"].",".
 				                                          "thumb_w = ".$_REQUEST["thumb_w"].",".
 				                                          "thumb_h = ".$_REQUEST["thumb_h"].",".
 				                                          "rss_items_count = ".$_REQUEST["rss_items_count"];
		

 		$success = $this->dbCon->queryDB($sql);
// 		echo "Sql-Query :_________________________<br> ".$sql."<br>__________________________________";
 		if ($success) {
 			$this->showSuccess($this->lang_admin["option_changed_success"]);
 			$this->options = $this->dbCon->getOptionsArray();
 			require("../language/".$this->options["language"]."/lang_admin.php");
 			$this->lang_admin = $lang_admin;
 			$this->createHeader($this->lang_admin["option_title"]);
 		}
 		else {
 			$this->showError($this->lang_admin["option_changed_error"]);
 			echo mysql_error();
 		}
 		
 	}
 	
 	function allFieldsFilled(){
 		foreach($_REQUEST as $key => $value){
 			if($value == "") return false;
 			if($key == "max_items_per_page" || $key == "max_media_size" || $key == "max_images" || 
 			   $key == "max_videos" || $key == "max_audios" || $key == "seconds_to_recount" || 
 			   $key == "seconds_to_email_check" || $key == "thumb_w" || $key == "thumb_h" || 
 			   $key == "rss_items_count")
 			   	if(!preg_match("/[0-9]+/", $value)) return false;
  		}	
  		return true;
 	}
 	
 	function createDisplayOptions(){
 		$languages = $this->getLanguagesAvailable();
    	$templates = $this->getTemplatesAvailable();
    	$categories = $this->cat_manager->getAllCategoriesWithCount($this->item_manager);
    	
    	$this->my_smarty->assign("fieldset_legend_standard", $this->lang_admin["fieldset_legend_standard"]);
    	$this->my_smarty->assign("fieldset_legend_file", $this->lang_admin["fieldset_legend_file"]);
    	$this->my_smarty->assign("fieldset_legend_item", $this->lang_admin["fieldset_legend_item"]);
    	$this->my_smarty->assign("fieldset_legend_expert", $this->lang_admin["fieldset_legend_expert"]);
    	$this->my_smarty->assign("languages", $languages);
    	$this->my_smarty->assign("templates", $templates);
    	$this->my_smarty->assign("categories", $categories);
    	$this->my_smarty->assign("options", $this->options);
    	$this->my_smarty->assign("option_no", $this->lang_admin["option_no"]);
    	$this->my_smarty->assign("option_yes", $this->lang_admin["option_yes"]);
    	$this->my_smarty->assign("option_labels", $this->lang_admin["option_labels"]);
    	$this->my_smarty->assign("option_button", $this->lang_admin["option_button"]);
    	$this->my_smarty->assign("option_tooltips", $this->lang_admin["option_tooltips"]);
    }
 	
 	/**
	 * gets the languages that are available and returns them in an array
	 */
  	function getLanguagesAvailable() {
  		$languages_array = array();
		$this->folder_manager->listLanguages("../language/", $languages_array);
	    return $languages_array;
  	}
  	
  	/**
	 * gets the templates that are available and returns them in an array
	 */
  	function getTemplatesAvailable() {
  		$templates_array = array();
		$this->folder_manager->listTemplates("../templates/", $templates_array);
	    return $templates_array;
  	}
	
	function getScriptName() {
 		global $php_extension;
   	    return "options.".$php_extension;
    }
 }
 
 $options_view = new OptionsView();
 $options_view->display();
?>
