<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 16.06.2005
 * 
 * This script shows the ranks and offers all ways to modify ranks.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 
 class RankView extends AdminView {
 	
 	function RankView() {
 		global $config;
 		parent::AdminView();
 		$this->setTitle($this->lang_admin["ranks_title"]);
 	}
 	
 	function display() {
 		$this->my_smarty->assign("ranks_title", $this->lang_admin["ranks_title"]);
 		
 		if(isset($_REQUEST["do"])) {
 			if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "add") $this->showRankForm();
 			else if(isset($_POST["do"]) && $_POST["do"] == "add_rank") $this->addRank();
 			else if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "edit_rank" && $_REQUEST["rankID"] != "") $this->editRank($_REQUEST["rankID"]);
 			else if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "save_edit_rank" && $_REQUEST["rankID"] != "") $this->saveEditedRank($_REQUEST["rankID"]);
 		} else {
 			$this->showRanks();
 		}
 	}
 	
 	/**
 	 * Creates the menu for adding new ranks.
 	 */
 	function showRankForm() {
 		$this->my_smarty->assign('rank_labels',$this->lang_admin["rank_table_header"]);
 		$this->my_smarty->assign('allowed',$this->lang_admin["allowed"]);
 		$this->my_smarty->assign('forbidden',$this->lang_admin["forbidden"]);
 		$this->my_smarty->assign('add_rank_button',$this->lang_admin["add_rank_button"]);
 		$this->my_smarty->assign('add_rank_title',$this->lang_admin["add_rank_title"]);
 		
 		$this->my_smarty->display('rank_form.tpl');
 	}
 	
 	/**
 	 * Creates the menu for editing ranks.
 	 */
 	function editRank($rankID) {
 		$rank = $this->rank_manager->getRankByID($rankID);
 		$this->my_smarty->assign('rank',$rank);
 		$this->my_smarty->assign('rank_labels',$this->lang_admin["rank_table_header"]);
 		$this->my_smarty->assign('allowed',$this->lang_admin["allowed"]);
 		$this->my_smarty->assign('forbidden',$this->lang_admin["forbidden"]);
 		$this->my_smarty->assign('edit_rank_button',$this->lang_admin["edit_rank_button"]);
 		$this->my_smarty->assign('edit_rank_title',$this->lang_admin["edit_rank_title"]);
 		
 		$this->my_smarty->display('rank_edit.tpl');
 	}
 	
 	function showRanks() {
 		$ranks = $this->rank_manager->getAllRanks();
 		$this->my_smarty->assign('rank_labels',$this->lang_admin["rank_table_header"]);
 		$this->my_smarty->assign('allowed',$this->lang_admin["allowed"]);
 		$this->my_smarty->assign('forbidden',$this->lang_admin["forbidden"]);
 		$this->my_smarty->assign('ranks',$ranks);
 		
 		$this->my_smarty->display('rank_list.tpl');
    }
    
    function saveEditedRank($rankID){
    	if(!$_POST["rank_name"] || $_POST["rank_name"] == "") {
    		$this->showError($this->lang_admin["missing_rank_name_error"]);
 		    $this->my_smarty->assign('rank_name_class',"red_border");
    		$this->editRank($rankID);
    		return;
    	} 
    	/*else if($this->rank_manager->existsRank($_POST["rank_name"])) {
    		$this->showError($this->lang_admin["existing_rank_name_error"]);
 		    $this->my_smarty->assign('rank_name_class',"red_border");
    		$this->editRank($rankID);
    		return;
    	}*/
    	$this->rank_manager->editRank($_POST);
    	$this->showSuccess($this->lang_admin["rank_edited"]);
    	$this->showRanks();
    }
    
    function addRank() {
    	if(!$_POST["rank_name"] || $_POST["rank_name"] == "") {
    		$this->showError($this->lang_admin["missing_rank_name_error"]);
 		    $this->my_smarty->assign('rank_name_class',"red_border");
    		$this->showRankForm();
    		return;
    	} else if($this->rank_manager->existsRank($_POST["rank_name"])) {
    		$this->showError($this->lang_admin["existing_rank_name_error"]);
 		    $this->my_smarty->assign('rank_name_class',"red_border");
 		    $this->my_smarty->assign('rank_name_value',$_POST["rank_name"]);
    		$this->showRankForm();
    		return;
    	}
    	$this->rank_manager->addRank($_POST);
    	$this->showSuccess($this->lang_admin["rank_added"]);
    	$this->showRanks();
    }
 }
 
 $rank_view = new RankView();
 $rank_view->display();
?>
