<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 07.06.2005
 * 
 * This script shows the user administration dialogue and lets the admin 
 * delete users or change their ranks
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 
 class UserView extends AdminView {
 	
 	var $rank_manager;
 	
 	function UserView() {
 		global $config;
 		parent::AdminView();
 		$this->setTitle($this->lang_admin["user_admin_title"]);
 	}
 	
 	function display() {
 		$this->my_smarty->assign("user_admin_title", $this->lang_admin["user_admin_title"]);
 		
 		$this->showUsers();
 		
 		$this->my_smarty->display('show_users.tpl');
 	}
 	
 	function showUsers() {
 		global $php_extension;
 		if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "delete" && isset($_REQUEST["userID"])){
	 		if($this->user_manager->userIDExists($_REQUEST["userID"])){
	 			if(!$this->user_manager->userIsAdmin($_REQUEST["userID"])){
	 				$this->my_smarty->assign("dialogue_title", $this->lang_admin["dialogue_delete_title"]);
		 			$this->my_smarty->assign("dialogue_text", $this->lang_admin["dialogue_delete_user"]);
		 			$this->my_smarty->assign("dialogue_url", "show_users.".$php_extension);
		 			$this->my_smarty->assign("dialogue_do_value", "delete");
		 			$this->my_smarty->assign("confirm_id", $_REQUEST["userID"]);
		 			$this->my_smarty->assign("yes_button", $this->lang_admin["yes_button"]);
		 			$this->my_smarty->assign("no_button", $this->lang_admin["no_button"]);
	 			}
	 			else $this->showError($lang_admin["admin_not_deletable"]);	 		
	 		}
	 	}
	 	else if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "delete" && isset($_REQUEST["confirm_id"]) && isset($_REQUEST["yes_button"])){
	 		if($this->user_manager->userIDExists($_REQUEST["confirm_id"])){
	 			$this->user_manager->deleteUser($_REQUEST["confirm_id"]);
	 		}
	 	}
 		
 		if(isset($_REQUEST["sort"])){
 			$sort = $_REQUEST["sort"];
 			if(isset($_REQUEST["direction"])){
	 			$direction = $_REQUEST["direction"];
	 			if ($sort == "" && $direction == "") $users = $this->user_manager->getAllUsersOrdered();
		 		else $users = $this->user_manager->getAllUsersOrdered($sort, $direction);
	 		}
	 		else $users = $this->user_manager->getAllUsersOrdered($sort, "asc");
	 		
	 	}
	 	else $users = $this->user_manager->getAllUsersOrdered();
	 	
 		$this->my_smarty->assign("user_labels", $this->lang_admin["user_table_header"]);
 		$this->my_smarty->assign("users", $users);
 		
 	}
 }
 
 $user_view = new UserView();
 $user_view->display();
?>
