<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 07.06.2005
 * 
 * This script shows the user administration dialogue and lets the admin 
 * delete users or change their ranks
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('../classes/AdminView.class.php');
 
 class SpamList extends AdminView {
 	
 	
 	function SpamList() {
 		global $config;
 		parent::AdminView();
 		$this->setTitle($this->lang_admin["spam_list_title"]);
 	}
 	
 	function display() {
 		if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "save"){
 			$this->saveChanges();
 		}
 		
 		if(isset($_GET["deleteID"]) && $_GET["deleteID"] != ""){
 			$deleteID = $_GET["deleteID"];
			$this->deleteEntryFromList($deleteID);
 		}
 		
 		$this->show_list();
 		
 		$this->my_smarty->display('spamlist.tpl');
 	}
 	
 	function show_list(){
 		$this->my_smarty->assign("spam_list_title", $this->lang_admin["spam_list_title"]);
 		$this->my_smarty->assign("spam_submit_button", $this->lang_admin["spam_submit_button"]);
 		$this->my_smarty->assign("spamlist_mail_label", $this->lang_admin["spamlist_mail_label"]);
 		$this->my_smarty->assign("spamlist_delete_label", $this->lang_admin["spamlist_delete_label"]);
 		$spamlist = $this->getSpamList();
 		if($spamlist != null) $this->my_smarty->assign("spamlist", $spamlist);
 		else $this->my_smarty->assign("no_spamlist", $this->lang_admin["no_spamlist"]);
 		
 		$this->my_smarty->assign("php_self", "spamlist.".$php_extension);
 	}
 	
 	function getSpamList(){
 		global $config;
 		$sql = "select * from ".$config["db_prefix"]."spam_list order by email";
 		$result = $this->dbCon->selectFromDB($sql);
 		
 		$spamlist = array();
 		while($row = mysql_fetch_assoc($result)){
 			$spamlist[count($spamlist)] = $row;
 		}
 		if(count($spamlist) > 0) return $spamlist;
 		return null;
  	}
 	
 	function saveChanges(){
 		global $config;
 		if(isset($_POST["email"]) && $_POST["email"] != ""){
 			$email = $_POST["email"];
 			$sql = "insert into ".$config["db_prefix"]."spam_list (email) values ('$email')";
 			$insert = $this->dbCon->insertIntoDB($sql);
 			if($insert) {
 				$this->my_smarty->assign("success_title", $this->lang_admin["success_title"]);
 				$this->my_smarty->assign("success_message", $this->lang_admin["success_spamlist_added"]);
 			}
 		}
 		else {
 			$this->my_smarty->assign("error_title", $this->lang_admin["error_title"]);
 			$this->my_smarty->assign("error_message", $this->lang_admin["error_spamlist_added"]);
 		}
 	}
 	
 	function deleteEntryFromList($id){
 		global $config;
 		$sql = "delete from ".$config["db_prefix"]."spam_list where id=$id";
 		$delete = $this->dbCon->queryDB($sql);
 		if($delete){
 			$this->my_smarty->assign("success_title", $this->lang_admin["success_title"]);
 			$this->my_smarty->assign("success_message", $this->lang_admin["success_spamlist_deleted"]);
 		}
 	}
 	
 }
 
 $spam_list = new SpamList();
 $spam_list->display();
?>
