<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/


 require_once("../config.php");
 require_once("../extension.inc");
 require_once($config["proj_path"].'/classes/MySmarty.class.php');
 require_once($config["proj_path"].'/classes/DBConManager.class.php');
 require_once($config["proj_path"].'/classes/SessionManager.class.php');
 require_once($config["proj_path"].'/classes/UserManager.class.php');
 require_once($config["proj_path"].'/classes/RankManager.class.php');

class AdminView {
    var $my_smarty;
    var $dbCon;
    var $options;
    var $session_manager;
    var $user_manager;
    var $rank_manager;
 	var $valid_user;
 	var $user;
 	var $lang_admin, $lang_encoding, $lang_error, $lang_main;
    
    function AdminView() {
    	global $config;
    	$this->valid_user = false;
    	$this->my_smarty = new MySmarty("../",TMPL_ADMIN);
 		$this->session_manager = new SessionManager();
    	$this->dbCon = new DBConManager($config);
    	$this->options = $this->dbCon->getOptionsArray();
 		$this->user_manager = new UserManager($this->dbCon,$config);
 		$this->rank_manager = new RankManager($this->dbCon,$config);
    	
    	// load language files
    	require("../language/".$this->options["language"]."/lang_admin.php");
    	require("../language/".$this->options["language"]."/lang_error.php");
    	require("../language/".$this->options["language"]."/lang_main.php");
    	require("../language/".$this->options["language"]."/lang.desc.php");
    	$this->lang_encoding = $lang_encoding;
    	$this->lang_admin = $lang_admin;
    	$this->lang_error = $lang_error;
    	$this->lang_main = $lang_main;
    	
 		if($this->session_manager->loggedIn()) {
		   $this->valid_user = $this->user_manager->isValidUser($this->session_manager->getUsername(),$this->session_manager->getUserpass());
		   if($this->valid_user) {
		   	  $this->user = $this->user_manager->getUser($this->session_manager->getUserID());
		   	  if(!$this->rank_manager->isAdmin($this->user))
		   	     $this->showErrorPage($this->lang_admin["no_admin_rights"]);
		   } else $this->showErrorPage($this->lang_admin["no_admin_rights"]);
		} else {
			$this->showErrorPage($this->lang_admin["no_admin_rights"]);
 		}
		
		$this->my_smarty->assign("javascript", "<SCRIPT type='text/javascript' language='javascript' src='../javascript/tooltip.js'></script>");
		
		
		$this->createHeader();
    }
    
    /**
     * Sets the title of the webpage.
     */
    function setTitle($title) {
    	$this->my_smarty->assign("title", $title);
    }
    
    function showErrorPage($error_message) {
    	$this->showError($error_message);
    	$this->my_smarty->assign("encoding", $this->lang_encoding);
    	$this->my_smarty->display('error.tpl');
    	exit;
    }
    
    function showError($error_message) {
	   $this->setTitle($this->lang_admin["error_title"]);
	   $this->my_smarty->assign('error_title',$this->lang_admin["error_title"]);
	   $this->my_smarty->assign('error_message',$error_message);
	}
	
	function showSuccess($success_message) {
		$this->setTitle($this->lang_admin["success_title"]);
	 	$this->my_smarty->assign('success_title',$this->lang_admin["success_title"]);
		$this->my_smarty->assign('success_message',$success_message);
	}
	
	function createHeader() {
     	global $config;
     	global $php_extension;
     	$this->my_smarty->assign("encoding", $this->lang_encoding);
     	$this->my_smarty->assign("php_extension", $php_extension);
 		
 		$this->createMenuStructure();
     }
     
     /**
      * Creates the basic menu structure with its different points
      */
     function createMenuStructure() {
     	$this->my_smarty->assign("options_menu", $this->lang_admin["option_title"]);
     	$this->my_smarty->assign("spam_label", $this->lang_admin["spam_label"]);
     	$this->my_smarty->assign("email_label", $this->lang_admin["email_label"]);
     	$this->my_smarty->assign("database_label", $this->lang_admin["database_label"]);
     	$this->my_smarty->assign("options_label", $this->lang_admin["option_label"]);
     	$this->my_smarty->assign("user_admin_label", $this->lang_admin["user_admin_label"]);
     	$this->my_smarty->assign("adduser_admin_label", $this->lang_admin["adduser_admin_label"]);
     	$this->my_smarty->assign("user_admin_menu", $this->lang_admin["user_admin_title"]);
     	$this->my_smarty->assign("ranks_menu", $this->lang_admin["ranks_title"]);
     	$this->my_smarty->assign("show_ranks_label", $this->lang_admin["show_ranks_label"]);
     	$this->my_smarty->assign("add_rank_label", $this->lang_admin["add_rank_label"]);
     	$this->my_smarty->assign("user_admin_label", $this->lang_admin["user_admin_label"]);
     	$this->my_smarty->assign("quit_admin_area_menu", $this->lang_admin["quit_admin_area_menu"]);
     	$this->my_smarty->assign("quit_admin_area", $this->lang_admin["quit_admin_area"]);
     }
}
?>