<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/


/**
 * Created on 29.03.2005
 *
 * This class checks a mailbox and extracts the attachments of every unread mail.
 *
 * @author Alexander De Luca, Michael Mueller
 * @version 0.8
 */

require($config["proj_path"].'classes/ItemParser.class.php');
require($config["proj_path"].'classes/OptionManager.class.php');

class CheckMail {

	var $numMsgs;
	var $mailbox;
	var $spam_list;
	var $option_manager;

	var $dbCon;
	var $config;

    function CheckMail($dbCon, $config) {
    	$this->dbCon = $dbCon;
    	$this->config = $config;

    	$this->getSpamList();

    }

    /**
     * Returns an array containing the data to retrieve an email, or null,
     * if there is no data.
     */
    function getEmailData() {
    	$sql = "Select * from ".$this->config["db_prefix"]."item_email";
    	$result = $this->dbCon->selectFromDB($sql);
    	while ($array = mysql_fetch_array($result)){
//    		echo $array["email"];
    		return $array;
    	}
    	return false;
    }

    /**
     * Saves the email data to the database.
     */
    function saveEmailData($email,$server,$port,$protocol,$password) {
    	$sql = "Delete from ".$this->config["db_prefix"]."item_email";
  		$delete = mysql_query($sql);
    	$sql = "INSERT INTO ".$this->config["db_prefix"]."item_email(email,server,port,protocol,password) " .
    			"VALUES('".$email."','".$server."','".$port."','".$protocol."','".$password."')";
    	echo $sql;
    	$result = $this->dbCon->insertIntoDB($sql);
  		return $result;
    }

    function newMailsAvailable(){
    	if (imap_num_recent($this->mailbox) > 0) return true;
    	return false;
    }

    function checkForMails(){
//    	echo "eins ";
    	if(!function_exists("imap_open")) {
		    return;
	    }
//	    echo "2 ";
		$email_data = $this->getEmailData();
//		echo "3 ";
		if(!$email_data) return;
//		echo "4 ";

		$mailboxAddress = "{".$email_data["server"]."/".
	    				          $email_data["protocol"].":".
	    				          $email_data["port"]."}INBOX";
//		echo "5 ";
//		echo "address = ".$mailboxAddress;
//		print_r($email_data);
    	$this->mailbox = imap_open($mailboxAddress, $email_data["email"], $email_data["password"]);
    	if ($this->mailbox){
//    		echo "<br />6";
			$check = imap_check($this->mailbox);
    		$this->numMsgs = $check->Nmsgs;
//    		echo "<br/>New Messages: ".$this->numMsgs;

    		if ($this->numMsgs > 0){
    			$this->checkMails();
    		}

    		//update the option 'last_email_check'
    		mysql_query("update ".$this->config["db_prefix"]."options set last_email_check=".time());
    	}
    	else echo "Keine Verbindung zur Mailbox";
    }

    function checkMails() {

    	if (!$this->newMailsAvailable())
    		return;

    	$item_parser = new ItemParser($this->dbCon, $this->config);
    	$allowed_media_formats = $this->dbCon->getAllowedMediaFormats();

    	// this loop walks across all emails
    	for($messageID = 1; $messageID <= $this->numMsgs; $messageID++){
    		$item_data = array();
    		$header = imap_header($this->mailbox, $messageID);
//    		echo "<p> header:<br/>";
//    		print_r($header);
//    		echo "</p>";
	    	//echo "<br/>Mail Nr. ".$messageID."<br/>";
	    	$item_data["timestamp"] = strtotime($header->date);
	    	if (isset($header->subject)){
	    		$item_data["title"] = utf8_decode(imap_utf8($header->subject));
	    		//echo "<br/>".$item_data["title"];
	    	}

	    	$item_data["user"] = $header->from[0]->mailbox."@".$header->from[0]->host;

	    	//test if the sender of this mail is on spam list in options
	    	if ($this->isOnSpamList($item_data["user"])){
	    		imap_delete($this->mailbox, $messageID);
	    		//echo "<br/>SPAM";
	    		continue;
	    	}

    		$structure = imap_fetchstructure($this->mailbox, $messageID);
            //            type == multipart
            if($structure->type == 1 || ($structure->ifsubtype && $structure->subtype == 'Mixed')) {
            	$parts = $structure->parts;
            	$i = 1;
            	$media_data = array();
            	foreach ($parts as $part){
//            		echo "<br/>Part $i hat den Typ ".$part->type." und das encoding = " .$part->encoding;
            		         //type == text       encoding != base64
            		if($part->type == 0 && $part->encoding != 3) {
            			$item_data["item_text"] = imap_qprint(imap_fetchbody($this->mailbox, $messageID,$i));
//            			echo "text 1 = ".$item_data["item_text"];
            		}
            		if($part->type == 1 && $part->encoding == 0){ //BEI OUTLOOK MAIL MIT BILD
//            			print_r($part);
            			if($part->ifsubtype == 1){
            				$subparts = $part->parts;
            				$s = 1;
            				foreach($subparts as $subp){
            					if($subp->type == 0 && $subp->encoding == 4 && $subp->subtype == "PLAIN") {
		            				$item_data["item_text"] = imap_qprint(imap_fetchbody($this->mailbox, $messageID, $s.".1"));
//		            				echo "text 3 = ".$item_data["item_text"]."<br/>";
            					$s++;
            					}
		            		}
            			}
            		}
            		else if($part->encoding == 3) {  // encoding == base64
            			if ($this->dbCon->attachmentFormatAllowed($allowed_media_formats, $part->dparameters[0]->value)){
            				$options = $this->dbCon->getOptionsArray();
        					if(($part->bytes/1024) > $options["max_media_size"]){
        						//echo "<br/>Fehler:    ".$part->dparameters[0]->value." (".(int)($part->bytes / 1024)." KB) ist grer als max_media_size (".($options["max_media_size"])." KB) aus den Options<br/>";
        					}
        					else $media_data[count($media_data)] = array("name"=>$part->dparameters[0]->value, "data"=>imap_base64(trim(imap_fetchbody($this->mailbox, $messageID,$i))));
            			}
            			else echo "<br/>".substr($part->dparameters[0]->value, strrpos($part->dparameters[0]->value, ".")+1)." Format nicht in Options angegeben<br/>";
					}
            		$i++;
	    			//print_r($part);
	    		}
	    		//print_r($media_data);
	    		if(count($media_data) > 0) {
	    			$item_data["media_data"] = $media_data;
	    			//print_r($media_data);
	    		}
            } else if($structure->type == 0) { //type == text
            	$item_data["item_text"] = imap_qprint(imap_body($this->mailbox, $messageID));
//            	echo "text 2 = ".$item_data["item_text"];
            }
            $itemID = $item_parser->parseItem($item_data);
            if ($itemID > 0){
            	imap_delete($this->mailbox, $messageID);
            }
            //echo "<br/>________________________________________<br/>";
    	}
    	imap_expunge($this->mailbox);
    }

    function isOnSpamList($user){
    	if (in_array($user, $this->spam_list)) return true;
 		return false;
    }

    function getSpamList(){
    	$spam_list_result = $this->dbCon->selectFromDB("Select * from ".$this->config["db_prefix"]."spam_list");
    	$array = array();
    	while ($row = mysql_fetch_array($spam_list_result)){
    		$array[count($array)] = $row["email"];
        }
        $this->spam_list = $array;
    }

}
?>