<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/


/**
 * Created on 18.03.2005
 * 
 * This class opens the connection to a MySQL-Database and offers some functions
 * to execute SQL-queries in the database
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */

class DBConManager {
	
	var $dbHost;
	var $dbName;
	var $dbUser;
	var $dbPass;
	var $config;

	/**
	  * The class constructor.
	  */
    function DBConManager($config) {
    	$this->config = $config;
    	
    	$this->dbHost = $config["dbhost"];
    	$this->dbName = $config["dbname"];
    	$this->dbUser = $config["dbuser"];
    	$this->dbPass = $config["dbpass"];
    	
    	if($this->dbHost != "" && $this->dbUser != "" && $this->dbName != ""){
    		$con = mysql_connect($this->dbHost, $this->dbUser, $this->dbPass);
    		if ($con){
    			$db_selected = mysql_select_db($this->dbName, $con);
    			if (!$db_selected){
    				echo "No database selected";
    			}
    		}
    	}
    	else {
    		echo "ooohhh";
    	}
    }
    
    function insertIntoDB($sql){
    	$success = mysql_query($sql);
    	return $success;
    }
    
    function selectFromDB($sql){
    	return mysql_query($sql);
    }
    
    function queryDB($sql){
    	return mysql_query($sql);
    }
    
    function selectNumRows($sql){
    	$result = mysql_query($sql);
    	if ($result){
    		return mysql_num_rows($result);
    	}
    	else {
    		//	    my_smarty->assign('error_title', $lang_error["mysql_error"]);
    		//		my_smarty->assign('error_msg', mysql_error());
    	}
    }
    
    /**
     * checks if the emails have to be checked again
     * 
     * @return true if it has to be checked. else false
     */
    function itsTimeToCheck(){
    	$result = $this->selectFromDB("select last_email_check, seconds_to_email_check from ".$this->config["db_prefix"]."options");
    	while ($row = mysql_fetch_array($result)){
    		$last_email_check = $row["last_email_check"];
    		$seconds_to_email_check = $row["seconds_to_email_check"];
    		return time() > $last_email_check + $seconds_to_email_check;
    	}
    }
    
    
    
    /**
     * Returns an array containing all allowed media formats specified in options in the db.
     */
     function getAllowedMediaFormats(){
     	$result = $this->selectFromDB("select media_formats_allowed from ".$this->config["db_prefix"]."options");
     	$result_array = mysql_fetch_array($result);
     	$media_format = $result_array["media_formats_allowed"];
     	$array = explode(", ", $media_format);
     	foreach ($array as $lala){
     		$lala = trim(strtolower($lala));
     	}
     	return $array;
     }
     
     /**
      * Checks if the media_formats_allowed-Array contains the given file extension
      * @param $media_formats_allowed Array containing all the file formats that are allowed for upload
      * @param $filename the filename of the attachment in the e-mail
      */
      function attachmentFormatAllowed($media_formats_allowed, $filename){
      	 //get the file extension
         $extension = strtolower(substr($filename, strrpos($filename, ".")+1));
         if (in_array($extension, $media_formats_allowed)){
         	return true;
         }
         return false;     	
      }
      
      /**
       * Returns an array containing all options from the database or false.
       * 
       * @return an associative array containing all options from the database or false
       */
      function getOptionsArray(){
      	
      	$options = array();
      	$sql = "Select * from ".$this->config["db_prefix"]."options";
      	$result = $this->selectFromDB($sql);
      	while($row = mysql_fetch_array($result)){
      		return $row;
      	}
      	return false;
      }
      
      function getMrepEmail(){
      	$sql = "Select * from ".$this->config["db_prefix"]."item_email";
      	$result = $this->selectFromDB($sql);
      	while($row = mysql_fetch_array($result)){
      		return $row["email"];
      	}
      	
      }
    
}
?>