<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/


/**
 * Created on 19.07.2005
 * 
 * This class provides functions to check different options.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
class OptionManager {
	
	var $dbCon;
	var $config;
	var $options;

   function OptionManager($dbCon, $config, $options) {
    	$this->dbCon = $dbCon;
    	$this->config = $config;
    	$this->options = $options;
   }
   
   /**
    * Checks, if a file format is allowed.
    * 
    * @return True, if it is allowed, else false.
    */
   function formatAllowed($format) {
   	  $formats = explode(",",$this->options["media_formats_allowed"]);
   	  
   	  foreach($formats as $act_format) {
   	  	if(trim($format) == trim($act_format)) return true;
   	  }
   	  return false;
   }
}
?>