<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/


/**
 * Created on 02.06.2005
 * 
 * This class does all the work on the user management
 * It contains functions to check if an user is a valid user 
 * or if an user exists and a function to add an user in the database
 * 
 * To use this class, it is required, that a connection
 * to the I-Reporter Database has already been established.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
class UserManager {
	
	var $dbCon;
	var $config;

   function UserManager($dbCon, $config) {
    	$this->dbCon = $dbCon;
    	$this->config = $config;
   }
    
  /**
   * Checks an user's name and password. Returns true if the user is valid
   * else false. 
   */
  function isValidUser($username, $password){
  	$sql = "Select * from ".$this->config["db_prefix"]."user where username='".$username."' and password=md5('".$password."')";
  	$result = $this->dbCon->selectFromDB($sql);
  	while($row = mysql_fetch_array($result)){
  		return true;
  	}
  	return false;
  }
  
  function userIsAdmin($userID){
  	$sql = "Select * from ".$this->config["db_prefix"]."user where userID=$userID";
  	$result = $this->dbCon->selectFromDB($sql);
  	while($row = mysql_fetch_array($result)){
  		if ($row["rank"] == 1) return true;
  	}
  	return false;
  }
  
  /**
   * Checks if the given username already exists
   * @param $username the username 
   * @return returns true if the username exists, else false
   */
  function userExists($username){
  	$sql = "Select * from ".$this->config["db_prefix"]."user where username='".$username."'";
  	$result = $this->dbCon->selectFromDB($sql);
  	while($row = mysql_fetch_array($result)){
  		return true;
  	}
  	return false;
  }
  
  
  /**
   * Checks if the given userID exists already
   * @param $userID the userID 
   * @return returns true if the userID exists, else false
   */
  function userIDExists($userID){
  	$sql = "Select * from ".$this->config["db_prefix"]."user where userID=".$userID;
  	$result = $this->dbCon->selectFromDB($sql);
  	while($row = mysql_fetch_array($result)){
  		return true;
  	}
  	return false;
  }
  
  function getUserIDByUsername($username) {
  	$sql = "Select * from ".$this->config["db_prefix"]."user where username='".$username."'";
  	$result = $this->dbCon->selectFromDB($sql);
  	while($row = mysql_fetch_array($result)){
  		return $row["userID"];
  	}
  	return false;
  }
  
  function getUser($userID) {
  	$sql = "Select * from ".$this->config["db_prefix"]."user where userID=".$userID;
  	$result = $this->dbCon->selectFromDB($sql);
  	while($row = mysql_fetch_array($result)){
  		return $row;
  	}
  	return false;
  }
  
  
  function changeUser($userID,$username,$firstname,$lastname,$email,$mobilephone_number,$password, $new_password){
		if($new_password == "") 
			$sql = "UPDATE ".$this->config["db_prefix"]."user set username='".$username."',firstname='".$firstname."',lastname='".$lastname."'," .
					"email='".$email."',mobilephone_number='".$mobilephone_number."',password=md5('".$password."') where userID=$userID";
		else $sql = "UPDATE ".$this->config["db_prefix"]."user set username='".$username."',firstname='".$firstname."',lastname='".$lastname."'," .
					"email='".$email."',mobilephone_number='".$mobilephone_number."',password=md5('".$new_password."') where userID=$userID";
		//echo $sql;
		$result = $this->dbCon->insertIntoDB($sql);
	  	return $result;
  }
  
  /**
   * this function adds an user with all its details into the db
   */
  function addUser($username,$firstname,$lastname,$email,$mobilephone_number,$password){
  	$sql = "INSERT INTO ".$this->config["db_prefix"]."user(username,firstname,lastname,email,mobilephone_number,password,rankID) " .
  			"VALUES('".$username."','".$firstname."','".$lastname."','".$email."','".$mobilephone_number."',md5('".$password."'),2)";
  	$result = $this->dbCon->insertIntoDB($sql);
  	return $result;
  }
  
  function getAllUsersOrdered($order_by = "username", $direction = "asc") {
  	$sql = "Select * from ".$this->config["db_prefix"]."user natural join ".$this->config["db_prefix"]."rank order by ".$order_by." ".$direction;
  	$result = $this->dbCon->selectFromDB($sql);
  	$users = array();
	while($row = mysql_fetch_array($result)){
		$users[count($users)] = $row;
	}
  	return $users;
  }
  
  function deleteUser($userID){
  	$sql = "Delete from ".$this->config["db_prefix"]."user where userID = $userID";
  	$delete = mysql_query($sql);
  	if(!$delete) echo mysql_error();
  }
  
  function updateRank($userID, $rankID){
  	$sql = "update ".$this->config["db_prefix"]."user set rankID = $rankID where userID = $userID";
  	$update = mysql_query($sql);
  	if(!$update) {
  		echo mysql_error();
  		return false;
  	}
  	return true;
  }
  
  function hasEmail($userID){
  	if($userID != ""){
  		$sql = "select * from ".$this->config["db_prefix"]."user where userID = $userID";
  		//echo $sql;
	  	$result = $this->dbCon->selectFromDB($sql);
		while($row = mysql_fetch_array($result)){
			if($row["email"] != "") return $row["email"];
		}
	}
	return false;
  }
  
  function sendMailToUser($userID, $username, $subject, $message){
  	$to = $this->hasEmail($userID);
  	if($to){
  		$subject = "Mobile Reporter: ".$subject;
  		$message = $this->lang_main["mail_message_begin"].":\n\n".
  		           $this->lang_main["mail_sender"].": $username\n\n".
  		           $this->lang_main["message_label"].": \n".$message;
  		//echo "slfsl".$message;
  		$sendmail = mail($to, $subject, $message);
  		if($sendmail) return true;
  		else echo "fehler";
  	}
  	return false;
  }
  
  function sendMailToUserGuest($to, $username, $subject, $message){
  	echo "sadfkfsljf";
  	if($to != ""){
  		echo $to;
  		$subject = "Mobile Reporter: ".$subject;
  		$message = $this->lang_main["mail_message_begin"].":\n\n".
  		           $this->lang_main["mail_sender"].": $username\n\n".
  		           $this->lang_main["message_label"].": \n".$message;
  		echo "slfsl".$message;
  		$sendmail = mail($to, $subject, $message);
  		if($sendmail) return true;
  		else echo "fehler";
  	}
  	return false;
  }
}
?>