<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/


/**
 * Created on 27.03.2005
 * 
 * This class does all the work on the the views.
 * It adds new Views and creates the statistics.
 * 
 * To use this class, it is required, that a connection
 * to the I-Reporter Database has already been established.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */

class ViewManager {
    var $seconds_to_recount; // the time in seconds, from the db, until a visit counts again
    var $dbCon;
    var $config;
 
    function ViewManager($dbCon,$config) {
    	$this->dbCon = $dbCon;
    	$this->config = $config;
    	$options = $dbCon->getOptionsArray();
    	$this->seconds_to_recount = $options["seconds_to_recount"];
//    	$option_sql = "SELECT * FROM ".$config["db_prefix"]."options";
//    	$result = mysql_query($option_sql);
//    	while($row = mysql_fetch_array($result)) {
//    		$this->seconds_to_recount = $row["seconds_to_recount"];
//    	}
    }
    
    /**
     * Adds a view for a specific item.
     * But only if the visit comes from an ip adress,
     * that hasn't visited this item since the recount time
     * declared in the options.
     * 
     * @param $item_id the int ID of the item, that got a view
     * @param $is_user indicates, if the visit is from a member or a simple visitor
     *        default 'false'
     */
    function addView($item_id,$is_user = false) {
    	$visit_time = time();
    	// first delete all visits, that happened more than $seconds_to_recount before
    	$delete_old_visits_sql = "DELETE FROM ".$this->config["db_prefix"]."item_visit WHERE visit_time+".$this->seconds_to_recount."< ".$visit_time;
    	@mysql_query($delete_old_visits_sql);
    	// now check, if the users ip address visited this item
    	$user_ip = getenv("REMOTE_ADDR");
    	$visit_ip_count_sql = "SELECT count(*) AS visit_count FROM ".$this->config["db_prefix"]."item_visit WHERE itemID = ".$item_id." AND ip_address = '".$user_ip."'";
    	
    	$visit_ip_count_result = @mysql_query($visit_ip_count_sql);
    	while($visit_ip_count_row = mysql_fetch_array($visit_ip_count_result)) {
    		$visit_count = $visit_ip_count_row["visit_count"];
    		if($visit_count == 0) { // count the visit
    		    $insert_new_visit_sql = "INSERT INTO ".$this->config["db_prefix"]."item_visit VALUES(".$item_id.",'".$user_ip."',".$visit_time.")";
    			@mysql_query($insert_new_visit_sql);
    			
    			$visit_day = date("d",$visit_time);
    			$visit_month = date("m",$visit_time);
    			$visit_year = date("Y",$visit_time);
    			$view_count_sql = "SELECT count(*) AS view_count FROM ".$this->config["db_prefix"]."item_view WHERE itemID = ".$item_id." AND day = ".$visit_day." AND month = ".$visit_month." AND year = ".$visit_year;
    			$view_count_result = @mysql_query($view_count_sql);
    			while($view_count_row = mysql_fetch_array($view_count_result)) {
    				$view_count = $view_count_row["view_count"];
    				$count_kind = "visitor_count";
    				if($is_user) $count_kind ="user_count";
    				if($view_count == 0) {
    					$insert_view_sql = "INSERT INTO ".$this->config["db_prefix"]."item_view VALUES(".$item_id.",0,0,".$visit_day.",".$visit_month.",".$visit_year.")";
    					@mysql_query($insert_view_sql);
    					//echo $insert_view_sql;
    				}
    				$update_view = "UPDATE ".$this->config["db_prefix"]."item_view SET ".$count_kind." = ".$count_kind." + 1 WHERE itemID = ".$item_id." AND day = ".$visit_day." AND month = ".$visit_month." AND year = ".$visit_year;
    				@mysql_query($update_view);
    			}
    		}
    	}
    }
    
    /**
     * Returns an array containing "user_count" and "visitor_count".
     */
    function getViewsPerDay($itemID,$day,$month,$year) {
    	$sql = "Select * from ".$this->config["db_prefix"]."item_view ".
    			"where itemID = ".$itemID." and day = $day and month = $month and year = $year";
    	
    	$result = $this->dbCon->selectFromDB($sql);
    	while ($row = mysql_fetch_array($result)){
    		return $row;
    	}
    	return array("user_count" => 0, "visitor_count" => 0);
    }
    
    /**
     * Returns an array containing "user_count" and "visitor_count".
     */
    function getViewsPerMonth($itemID,$month,$year) {
    	$sql = "Select sum(user_count) as user_count, sum(visitor_count) as visitor_count from ".$this->config["db_prefix"]."item_view ".
    			"where itemID = ".$itemID." and month = $month and year = $year";
    	
    	$result = $this->dbCon->selectFromDB($sql);
    	while ($row = mysql_fetch_array($result)){
    		if($row["user_count"]!=null)
    		   return $row;
    	}
    	return array("user_count" => 0, "visitor_count" => 0);
    }
    
    /**
     * Returns an array containing "user_count" and "visitor_count".
     */
    function getViewsPerYear($itemID,$year) {
    	$sql = "Select sum(user_count) as user_count, sum(visitor_count) as visitor_count from ".$this->config["db_prefix"]."item_view ".
    			"where itemID = ".$itemID." and year = $year";
    	
    	$result = $this->dbCon->selectFromDB($sql);
    	while ($row = mysql_fetch_array($result)){
    		if($row["user_count"]!=null)
    		   return $row;
    	}
    	return array("user_count" => 0, "visitor_count" => 0);
    }
    
    /**
     * Returns an array containing all days found fot the specific
     * month and year. Every Day consists of an array containing
     * "user_count" and "visitor_count" and the height.
     */
    function getDaysOfMonth($itemID,$month,$year) {
    	$sql = "Select * from ".$this->config["db_prefix"]."item_view ".
    			"where itemID = ".$itemID." and month = $month and year = $year";
    	
    	$result = $this->dbCon->selectFromDB($sql);
    	$days = array();
    	$most_views_arr = $this->getMaxOfMonth($itemID,$month,$year);
    	$most_views = $most_views_arr["visitor_count"];
    	if($most_views_arr["user_count"] > $most_views)
    	   $most_views = $most_views_arr["user_count"];
    	while ($row = mysql_fetch_array($result)){
    		$days[$row["day"]] = $row;
    		$days[$row["day"]]["visitor_height"] = round(($row["visitor_count"] / $most_views) * 100);
    		$days[$row["day"]]["user_height"] = round(($row["user_count"] / $most_views) * 100);
    		if($days[$row["day"]]["visitor_height"] == 0) $days[$row["day"]]["visitor_height"] = 1;
    		if($days[$row["day"]]["user_height"] == 0) $days[$row["day"]]["user_height"] = 1;
    	}
    	// create the missing days
 		$days_for_month = cal_days_in_month(CAL_GREGORIAN, $month, $year);
 		for($i = 1; $i <= $days_for_month; $i++) {
 			if(!isset($days[$i])) {
 			   $days[$i] = array("visitor_count" => 0, "user_count" => 0, "day" => $i, "month" => $month, "year" => $year);
 			   $days[$i]["visitor_height"] = 1;
    		   $days[$i]["user_height"] = 1;
 			}
 		}
    	return $days;
    }
    
    /**
     * Returns the max user and visitor count of a specific month.
     */
    function getMaxOfMonth($itemID,$month,$year) {
    	$sql = "Select max(user_count) as user_count, max(visitor_count) as visitor_count from ".$this->config["db_prefix"]."item_view ".
    			"where itemID = ".$itemID." and month = $month and year = $year";
    	
    	$result = $this->dbCon->selectFromDB($sql);
    	while ($row = mysql_fetch_array($result)){
    		if($row["user_count"]!=null)
    		   return $row;
    	}
    	return array("user_count" => 0, "visitor_count" => 0);
    }
}
?>