<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on Sept 25, 2005
 * 
 * This script receives post submissions for communication between clients
 * and the server and answers them in a specific xml format.
 * For example it sends the rss file of a category when askes to.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once("config.php");
 require_once($config["proj_path"]."/classes/Response.class.php");
 require_once($config["proj_path"]."/classes/DBConManager.class.php");
 require_once($config["proj_path"]."/classes/MySmarty.class.php");
 require_once($config["proj_path"]."/classes/CategoryManager.class.php");
 require_once($config["proj_path"]."/classes/ItemManager.class.php");
 require_once($config["proj_path"]."/classes/FeedCreator.class.php");
 
 
 $dbCon = new DBConManager($config);
 $response = new Response();
 $options = $dbCon->getOptionsArray();
 $my_smarty = new MySmarty();
 $cat_manager = new CategoryManager($dbCon,$config);
 $item_manager = new ItemManager($dbCon, $config, $options);
 $feed_creator = new FeedCreator($dbCon,$config);
 
 require_once("./language/".$options["language"]."/lang_error.php");
 require("./language/".$options["language"]."/lang.desc.php");
 
 if (isset($_REQUEST["do"])){
 	if($_REQUEST["do"] == "getcats") { // user wants the categories
	 	$categories = $cat_manager->getAllCategoriesWithCount($item_manager);
	 	$my_smarty->assign('categories',$categories);
	 	$my_smarty->assign('lang_encoding',$lang_encoding);
	 	
	 	$cat_xml = $my_smarty->fetch($options["template"].'/xml/comcats.tpl');
	 	$response->sendXML($cat_xml);
 	} else if($_REQUEST["do"] == "getcat") {
 		if(isset($_REQUEST["id"]))
 			$response->sendXML($feed_creator->createRSSFeed($_REQUEST["id"]));
 		else
 			$response->sendError($lang_error["missing_do_variable"]);
 	}
 	
 } else {
 	$response->sendError($lang_error["missing_do_variable"]);
 }
 
?>
