<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/*
 * Created on 30.08.2005
 * 
 * This script describes how items can be created and sent via
 * the different existing submission ways.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('./classes/DisplayView.class.php');
 
 class DownloadView extends DisplayView {
 	
 	function DownloadView() {
 		parent::DisplayView();
 		$this->setTitle($this->lang_main["download_title"]);
 	}
 	
 	function display() {
 		$this->my_smarty->assign("download_title", $this->lang_main["download_title"]);
 		$this->my_smarty->assign("download_description", $this->lang_main["download_description"]);
 		$this->my_smarty->assign("download_label", $this->lang_main["download_label"]);
 		$this->my_smarty->assign("download_link", $this->lang_main["download_link"]);
 		$this->my_smarty->assign("download_camera_label", $this->lang_main["download_camera_label"]);
 		$this->my_smarty->assign("download_j2me_label", $this->lang_main["download_j2me_label"]);
 		$this->my_smarty->assign("download_requirements_label", $this->lang_main["download_requirements_label"]);
 		
 		if(function_exists("filesize")) {
 			$size = filesize("./download/mrep.zip");
 			if($size != false) {
 				$kb_size = (int)($size/1000);
 				$this->my_smarty->assign("download_size", "(".$kb_size." ".$this->lang_main["download_kb_label"].")");
 				
 			}
 		}
 		
 		$this->my_smarty->display($this->options["template"].'/download.tpl');
 	}
 	
 	
	
	function getScriptName() {
		global $php_extension;
   	    return "download.".$php_extension;
    }
 }
 
 $download_view = new DownloadView();
 $download_view->display();
 
?>
