<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 28.07.2005
 *
 * This script shows a form to edit categories
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('./classes/DisplayView.class.php');
 
 class CreateCategoryView extends DisplayView {
 
	function CreateCategoryView() {
 		global $config;
 		parent::DisplayView();
 		$this->setTitle($this->lang_main["navigation_edit_category"]);
 	}	
 	
 	
 	function display() {
 		if(!$this->checkRights()) exit;
 		
 		if(isset($_REQUEST["do"]) && $_REQUEST["do"] == "save"){
 			$this->saveCategory();
 		}
 		if(isset($_REQUEST["catID"]) && $_REQUEST["catID"] != ""){
 			$cat = $this->cat_manager->getCatByID($_REQUEST["catID"]);
 			if($cat) $this->showForm($cat);
 			else $this->showErrorPage($this->lang_error["no_catID_specified"]);
 		}
 		else $this->showErrorPage($this->lang_error["no_catID_specified"]);
 		
 		
 		$this->my_smarty->display($this->options["template"].'/edit_category.tpl');
 	}
 	
 	/**
 	 * Checks if the user has the right to view the page.
 	 * If not it returns false.
 	 */
 	function checkRights() {
 		if($this->valid_user && !$this->rank_manager->editCategoryAllowed($this->user)) { // user without rights
 			$this->showErrorPage($this->lang_error["edit_category_forbidden"]);
 			return false;
 		} else if(!$this->valid_user ) { // user not logged in
 			$this->showErrorPage($this->lang_error["not_logged_in"]);
 			return false;
 		}
 		
 		return true;
 	}
 	
 	function showForm($cat) { 		
 		$this->my_smarty->assign('navigation_edit_category',$this->lang_main["navigation_edit_category"]);
		$this->my_smarty->assign('php_self',$this->createSelfURL());
		$this->my_smarty->assign('edit_category_label',$this->lang_main["edit_category_label"]);
		$this->my_smarty->assign('rss_items_count_label',$this->lang_main["rss_items_count_label"]);
		$this->my_smarty->assign('edit_category_button',$this->lang_main["edit_category_button"]);
		$this->my_smarty->assign('rss_items_count_value',$cat["rss_items_count"]);
		$this->my_smarty->assign('category_name',$cat["catname"]);
		$this->my_smarty->assign('catID',$cat["catID"]);
		
 	}
 	
 	function saveCategory(){
 		global $config;
 		
 		if(isset($_REQUEST["category"]) && $_REQUEST["category"] != ""){
 			$catname = $_REQUEST["category"];
 			if($this->cat_manager->isExistingCategoryName($catname, $_POST["catID"])){
 				$this->showError($this->lang_error["category_exists"]);
 			}
 			else {
 				if(isset($_REQUEST["rss_items_count"]) && $_REQUEST["rss_items_count"] != ""){
 					if(preg_match("/[0-9]+/", $_REQUEST["rss_items_count"])){
 						$rss_items_count = $_REQUEST["rss_items_count"];
 					}
 					else {
 						$this->showError($this->lang_error["rss_items_count_no_number"]);
 						return;
 					}
 				}
 				else $rss_items_count = $this->options["rss_items_count"];
 				
 				$sql = "update ".$config["db_prefix"]."category set catname='".$catname."', " .
 					   "rss_items_count=$rss_items_count where catID =".$_POST["catID"];
 				$ok = $this->dbCon->insertIntoDB($sql);
 				if($ok) {
 					$this->showSuccessPage($this->lang_main["edit_category_success"]);
 					exit;
 				}
 				else $this->showError(mysql_error());
 			}
 		}
 		else $this->showError($this->lang_error["category_is_missing"]);
 	}
 	
 	function getScriptName() {
 		global $php_extension;
   	    return "create_category.".$php_extension;
    }
 	
 }
 
 $create_category_view = new CreateCategoryView();
 $create_category_view->display();
 
 
?>
