<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/*
 * Created on 25.04.2005
 * 
 * This script shows and checks the register dialogue.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('./classes/DisplayView.class.php');
 
 class RegisterView extends DisplayView {
 	
 	function RegisterView() {
 		parent::DisplayView();
 		$this->setTitle($this->lang_main["change_data_title"]);
 		
 		$username_act = $this->session_manager->getUsername();
 		$password_act = $this->session_manager->getUserpass();
 	}
 	
 	function display() {
 		if($this->valid_user) {
 			if((isset($_POST["do"]) && $_POST["do"] == "change") && $this->checkInputfields()) {
	 			if($this->user_manager->changeUser($this->session_manager->getUserID(),$_POST["username"],$_POST["firstname"],
			    $_POST["lastname"],$_POST["email"],$_POST["mobile"],$_POST["old_password"], $_POST["new_password"])) {
			    	$this->showSuccess($this->lang_main["change_success"]);
			    	$this->my_smarty->display($this->options["template"].'/success.tpl');
			    	exit;
			    } 
			    else $this->showError($this->lang_error["change_failure"]);
			}
	 		$this->showForm();
	 		
	 		$this->my_smarty->display($this->options["template"].'/edit_data.tpl');
 		}
 	}
 	
 	function showForm() {
 		global $config;
 		
 		$user_data = $this->getUserData();
 		
 		$this->my_smarty->assign('change_data_title',$this->lang_main["change_data_title"]);
		$this->my_smarty->assign('php_self',$this->createSelfURL());
		$this->my_smarty->assign('change_data_message',$this->lang_main["change_data_message"]);
		$this->my_smarty->assign('firstname_label',$this->lang_main["firstname_label"]);
		$this->my_smarty->assign('firstname_value',$user_data["firstname"]);
		$this->my_smarty->assign('lastname_label',$this->lang_main["lastname_label"]);
		$this->my_smarty->assign('lastname_value',$user_data["lastname"]);
		$this->my_smarty->assign('email_label',$this->lang_main["email_label"]);
		$this->my_smarty->assign('email_value',$user_data["email"]);
		$this->my_smarty->assign('mobile_label',$this->lang_main["mobile_label"]);
		$this->my_smarty->assign('mobile_value',$user_data["mobilephone_number"]);
		$this->my_smarty->assign('username_label',$this->lang_main["username_label"]);
		$this->my_smarty->assign('username_value',$user_data["username"]);
		$this->my_smarty->assign('old_password_label',$this->lang_main["old_password_label"]);
		$this->my_smarty->assign('new_password_label',$this->lang_main["new_password_label"]);
		$this->my_smarty->assign('new_password_confirm_label',$this->lang_main["new_password_confirm_label"]);
	    $this->my_smarty->assign('change_button',$this->lang_main["change_button"]);
 	}
 	
 	function checkInputfields() {
	 	$missing_field = false;
	 	$req_fields = array(0 => 'firstname',1 => 'lastname',2 => 'email',3 => 'username', 4 => 'old_password');
	 	
	 	foreach($req_fields as $field) {
	 		if(!isset($_POST[$field]) || $_POST[$field]=="") {
	 		    $this->my_smarty->assign($field."_class","red_border");
	 		    $missing_field = true;
	 		}
	 	}
	 	
	 	if($missing_field) {
	 		$this->showError($this->lang_error["missing_input_fields"]);
	 		return false;
	 	}
	 	
	 	if(isset($_POST["old_password"]) && $_POST["old_password"] != ""){
	 		if(!$this->user_manager->isValidUser($this->session_manager->getUsername(), $_POST["old_password"]))
	 			return false;
	 	}
	 	
	 	if($_POST["new_password"] != $_POST["new_pwconfirm"]) {
	 		$this->my_smarty->assign("password_class","red_border");
	 		$this->my_smarty->assign("pwconfirm_class","red_border");
	 		$this->showError($this->lang_error["password_missmatch_error"]);
	 		return false;
	 	}
	 	return true;
	}
	
	function getUserData(){
		if($this->valid_user){
			$userID = $this->session_manager->getUserID();
			return $this->user_manager->getUser($userID);
		}
		return false;
	}
	
	function getScriptName() {
		global $php_extension;
   	    return "edit_data.".$php_extension;
    }
 }
 
 $register_view = new RegisterView();
 $register_view->display();
 
?>
