<?php

/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/*
 * Created on 17.03.2005
 *
 * The installation routine for the mobile reporter.
 */

require_once("../extension.inc");
if(!isset($config)) {
   $config = array("proj_path" => "../");
}

//include('../config.php');
require('../classes/FolderManager.class.php');
require('../classes/MySmarty.class.php');
require('../classes/SessionManager.class.php');
require('./functions/install.functions.php');

$my_smarty = new MySmarty("../",TMPL_INSTALL);
$folder_manager = new FolderManager();

$my_smarty->assign('php_extension',$php_extension);


// start check the session on the choosen language and include it
$session = new SessionManager();
if(!$session->getSessionVar("lang")) {
   $session->setSessionVar("lang","lang_english");
}
if(isset($_POST["do"]) && $_POST["do"] == "lang"){
	$session->setSessionVar("lang",$_POST["new_lang"]);
}
include("../language/".$session->getSessionVar("lang")."/lang_install.php");
include("../language/".$session->getSessionVar("lang")."/lang.desc.php");
// end check the session on the choosen language and include it
$my_smarty->assign("encoding",$lang_encoding);

if(isset($_POST["do"])) {
	if($_POST["do"] == "lang") { // the language is choosen
		showCreateDBDialog();
	} else if($_POST["do"] == "template") { // the template is choosen
		$config["db_prefix"] = $session->getSessionVar("prefix");
		$choosen_lang = $session->getSessionVar("lang");
		include("./sqldata/mysql_inserts.sql.php");
		
		@mysql_connect($session->getSessionVar("db_host"),$session->getSessionVar("db_user"),
		$session->getSessionVar("db_user_pass"));
		@mysql_select_db($session->getSessionVar("db_name"));
		
		foreach($mysql_templates[$_POST["template"]] as $mysql_command) { // create the tables
				@mysql_query($mysql_command);
			}
		echo mysql_error();
		$session->stopSession();
		showInstallDone();
	} else if(isset($_POST["check_button"]) || isset($_POST["mail_tmpl_btn"])) { // the db data is checked again
		showCreateDBDialog();
	} else if(isset($_POST["create_button"])) { // the relations and the inserts are beeing created
		if(!isset($_POST["adminname"]) || !preg_match('/([a-z]|[A-Z]|[0-9]){2,}/',$_POST["adminname"])) {
			showCreateDBDialog($lang_install["username_error"]);
		} else if(!isset($_POST["adminpw"]) || !preg_match('/([a-z]|[A-Z]|[0-9]){2,}/',$_POST["adminpw"])) {
			showCreateDBDialog($lang_install["password_error"]);
		} else if(!isset($_POST["adminpwconfirm"]) || $_POST["adminpwconfirm"] != $_POST["adminpw"]) {
			showCreateDBDialog($lang_install["password_missmatch_error"]);
		} else { // if everything is fine, start to create the relations
			@mysql_connect($_POST["db_host"],$_POST["db_user"],$_POST["db_user_pass"]);
			@mysql_select_db($_POST["db_name"]);
            
			$config["db_prefix"] = $_POST["db_prefix"];
			
			include("./sqldata/mysql_relations.sql.php");
			
			
			foreach($mysql_relations as $mysql_command) { // create the tables
				@mysql_query($mysql_command);
				$last_error = mysql_error();
				if(strlen($last_error) > 0) {
					showCreateDBDialog($lang_install["db_creation_error"],$last_error);
					return;
				}
			}
			$insert_user_name = $_POST["adminname"];
			$insert_user_pass = $_POST["adminpw"];
			$choosen_lang = $session->getSessionVar("lang");
			$insert_email_addr = $_POST["email_addr"];
			$insert_email_server = $_POST["email_srv"];
			$insert_email_port = $_POST["email_port"];
			if(strlen($insert_email_port) <= 0)
			    $insert_email_port = 80;
			$insert_email_protocol = $_POST["email_protocol"];
			$insert_email_password = $_POST["email_password"];
			include("./sqldata/mysql_inserts.sql.php");
			foreach($mysql_inserts as $mysql_command) { // do the inserts
				mysql_query($mysql_command);
				$last_error = mysql_error();
				if(strlen($last_error) > 0) {
					showCreateDBDialog($lang_install["db_creation_error"],$last_error);
					return;
				}
			}
			
			// add admin
			mysql_query($mysql_admin_insert); // $mysql_admin_insert is from mysq_inserts.sql.php
			$last_error = mysql_error();
			if(strlen($last_error) > 0) {
				showCreateDBDialog($lang_install["db_creation_error"],$last_error);
				return;
			}
			
			// add item email data if necessary
			if(isset($_POST["email_addr"]) && strlen($_POST["email_addr"]) > 0
			&& isset($_POST["email_srv"]) && strlen($_POST["email_srv"]) > 0
			&& isset($_POST["email_protocol"]) && strlen($_POST["email_protocol"]) > 0
			&& isset($_POST["email_password"]) && strlen($_POST["email_password"]) > 0) {
				mysql_query($mysql_email_insert); // $mysql_email_insert is from mysq_inserts.sql.php
				$last_error = mysql_error();
				if(strlen($last_error) > 0) {
					showCreateDBDialog($lang_install["db_creation_error"],$last_error);
					return;
				}
			}
			
			createConfigFile($_POST["db_host"], $_POST["db_user"], $_POST["db_user_pass"], $_POST["db_name"],
            $_POST["db_prefix"], $_POST["proj_url"], $_POST["proj_abs_path"]);
			$session->setSessionVar("db_host",$_POST["db_host"]);
			$session->setSessionVar("db_user",$_POST["db_user"]);
			$session->setSessionVar("db_user_pass",$_POST["db_user_pass"]);
			$session->setSessionVar("db_name",$_POST["db_name"]);
			$session->setSessionVar("prefix",$_POST["db_prefix"]);
			showTemplateChooser();
		}
	}
} else { // choose language
	$languages_array = array();
	$folder_manager->listLanguages("../language/",$languages_array);
	$lang_shorts = array();
    $lang_folders = array();
	foreach($languages_array as $found_language) {
	    $lang_shorts[count($lang_shorts)] = $found_language["lang_short"];
	    $lang_folders[count($lang_folders)] = $found_language["lang_folder"];
    }
    showLanguageDialog();
}

?> 
