<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

$mysql_relations = array();

$mysql_relations[0] =
"create table ".$config["db_prefix"]."item (
  itemID int(11) NOT NULL auto_increment,
  item_timestamp int(11) NOT NULL,
  title char(60) NOT NULL,
  userID int(11) NOT NULL,
  catID int(11) NOT NULL,
  location varchar(30), 
  item_text text,
  main_img int(11),
  creation_time  int(4),
  item_visible tinyint(1) NOT NULL default '1',
  PRIMARY KEY (itemID)  
)";

$mysql_relations[1] =
"create table ".$config["db_prefix"]."mediadata (
  mediaID int(11) NOT NULL auto_increment,
  filename varchar(50) NOT NULL,
  url varchar(255) NOT NULL,
  itemID int(11) NOT NULL,
  PRIMARY KEY (mediaID)
)";

$mysql_relations[2] =
"create table ".$config["db_prefix"]."user (
  userID int(11) NOT NULL auto_increment,
  username varchar(30) NOT NULL,
  firstname varchar(30) NOT NULL,
  lastname varchar(30) NOT NULL,
  email varchar(255) NOT NULL,
  mobilephone_number char(18),
  password varchar(32) NOT NULL,
  rankID int(11) NOT NULL,
  PRIMARY KEY (userID)
)";

$mysql_relations[3] =
"create table ".$config["db_prefix"]."comment (
  commentID int(11) NOT NULL auto_increment,
  itemID int(11) NOT NULL,
  comment_text text,
  comment_date int(11) NOT NULL,
  userID int(11) NULL,
  guest_name varchar(30) NULL,
  email_comment varchar(255) NULL,
  PRIMARY KEY (commentID) 
)";

$mysql_relations[4] =
"create table ".$config["db_prefix"]."rating (
  userID int(11) NOT NULL,
  itemID int(11) NOT NULL,
  rating tinyint(1) NOT NULL,
  PRIMARY KEY (userID, itemID)
)";

$mysql_relations[5] =
"create table ".$config["db_prefix"]."links (
  from_item int(11) NOT NULL,
  to_item int(11) NOT NULL,
  PRIMARY KEY (from_item, to_item)
)";

$mysql_relations[6] =
"create table ".$config["db_prefix"]."category (
  catID int(11) NOT NULL auto_increment,
  catname char(60) NOT NULL,
  rss_items_count tinyint(3) UNSIGNED NOT NULL default '5',
  PRIMARY KEY (catID)
)";

$mysql_relations[7] =
"create table ".$config["db_prefix"]."item_view (
  itemID int(11) NOT NULL,
  user_count int(11) NOT NULL default '0',
  visitor_count int(11) NOT NULL default '0',
  day tinyint(2) NOT NULL,
  month tinyint(2) NOT NULL,
  year int(4) NOT NULL,
  PRIMARY KEY (itemID, day, month, year)
)";

$mysql_relations[8] =
"create table ".$config["db_prefix"]."item_visit (
  itemID int(11) NOT NULL,
  ip_address char(15) NOT NULL,
  visit_time int(11) NOT NULL,
  PRIMARY KEY (itemID, ip_address)
)";

#   this table specifies different ranks to restrict the rights of the user
$mysql_relations[9] =
"create table ".$config["db_prefix"]."rank (
  rankID tinyint(3) NOT NULL auto_increment,
  rank_name char(30) NOT NULL,
  add_item tinyint(1) NOT NULL default '1',
  edit_own_items tinyint(1) NOT NULL default '1',
  edit_all_items tinyint(1) NOT NULL default '0',
  delete_own_items tinyint(1) NOT NULL default '0',
  delete_all_items tinyint(1) NOT NULL default '0',
  add_category tinyint(1) NOT NULL default '0',
  edit_category tinyint(1) NOT NULL default '0',
  delete_category tinyint(1) NOT NULL default '0',
  delete_all_comments tinyint(1) NOT NULL default '0',
  delete_own_comments tinyint(1) NOT NULL default '0',
  add_comment tinyint(1) NOT NULL default '1',
  rank_visible tinyint(1) NOT NULL default '1',
  is_admin tinyint(1) NOT NULL default '0',
  PRIMARY KEY (rankID)
)";

#   this table contains all the options which can be edited by the admin
#   media_formats_allowed specifies the media file formats that can occur in an item
#   max_image_size in KB
#   max_video_size in MB
#   max_audio_size in MB
#   max_text_size in characters
#   seconds_to_recount the time in seconds, until the same ip address is counted again
#   seconds_to_email_check the time in seconds, until the mailbox is checked again
#   last_email_check records, when the mailbox has be checked the last time
#	spam_list comma separated list: if an item is sent by an email-address from this list,
#                                   the email will be ignored and deleted

$mysql_relations[10] =
"create table ".$config["db_prefix"]."options (
  language varchar(30) NOT NULL default 'lang_english',
  template varchar(30) NOT NULL default 'ireporter1',
  date_format varchar(100) NOT NULL default 'l, m/d/Y H:i',
  split_item_date_format varchar(100) NOT NULL default 'l, m/d/Y',
  media_formats_allowed varchar(255) NOT NULL default 'jpg, gif, png, avi, mpg, wmv, wav, mp3',
  max_media_size int(4) NOT NULL default '1024',
  max_files tinyint(2) NOT NULL default '1',
  max_text_size int(10) NOT NULL default '1000',
  html_allowed tinyint(1) NOT NULL default '0',
  adjust_overview tinyint(1) NOT NULL default '0',
  comments_allowed tinyint(1) NOT NULL default '1',
  rating_allowed tinyint(1) NOT NULL default '1',
  registration_allowed tinyint(1) NOT NULL default '1',
  max_items_per_page tinyint(3) NOT NULL default '5',
  seconds_to_recount int(6) NOT NULL default '300',
  email_check_on tinyint(1) NOT NULL default '1',
  seconds_to_email_check int(6) NOT NULL default '300', 
  last_email_check int(11) NOT NULL,
  default_cat int(11) NOT NULL,
  thumb_w int(4) NOT NULL default '100',
  thumb_h int(4) NOT NULL default '100',
  ranking_on tinyint(1) NOT NULL default '1',
  rss_items_count tinyint(3) NOT NULL default '5'		
)";

$mysql_relations[11] =
"create table ".$config["db_prefix"]."spam_list (
   id tinyint(3) NOT NULL auto_increment,
   email varchar(200) NOT NULL default 'mailings@gmx.net',
   PRIMARY KEY (id)
)";

$mysql_relations[12] =
"create table ".$config["db_prefix"]."item_email (
   id tinyint(1) NOT NULL auto_increment,
   email varchar(255) NOT NULL,
   server varchar(255) NOT NULL,
   port int(6) NOT NULL default '80',
   protocol char(4) NOT NULL,
   password varchar(255) NOT NULL,
   PRIMARY KEY (id)
)";

?>