<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/*
 * Created on 04.06.2005
 * 
 * This script handles the login process.
 *
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */

 require_once('./classes/DisplayView.class.php');

 class LoginView extends DisplayView {
    
 	function LoginView() {
 		parent::DisplayView();
 		$this->setTitle($this->lang_main["login_title"]);
 	}
 	
 	function display() {
 		$this->showLoginForm();
 		$this->login();
 		
 		$this->my_smarty->display($this->options["template"].'/login.tpl');
 	}
 	
 	/**
 	 * Displays the Login Form.
 	 */
 	function showLoginForm() {
 		global $config;
 		
	    $this->my_smarty->assign('login_title',$this->lang_main["login_title"]);
		$this->my_smarty->assign('username_label',$this->lang_main["username_label"]);
		if(isset($_POST["username"])) $this->my_smarty->assign('username_value',$_POST["username"]);
		$this->my_smarty->assign('password_label',$this->lang_main["password_label"]);
		$this->my_smarty->assign('login_button',$this->lang_main["login_button"]);
		if(isset($_POST["log_ref"]) && $_POST["log_ref"]!="")
		   $this->my_smarty->assign('log_ref',$_POST["log_ref"]);
 	}
 	
 	function login() {
 		if(isset($_POST["do"]) && $_POST["do"] == "login") {
		 	if($this->checkInputFields()) {
		 		if($this->user_manager->isValidUser($_POST["username"],$_POST["password"])) {
		 			$session_user_id = $this->user_manager->getUserIDByUsername($_POST["username"]);
		 			$this->session_manager->addUser($_POST["username"],$_POST["password"],$session_user_id);
		 			// redirect the user to the webpage he came from
		 			if(isset($_POST["log_ref"]) && $_POST["log_ref"]!="")
						header("Location:".$_POST["log_ref"]);
				    $this->createHeader($this->lang_main["login_title"]);
					
		 		} else {
		 			$this->showError($this->lang_error["login_failure"]);
		 			return;
		 		}
		 	}
		}
 	}
 	
 	function checkInputfields() {
		if(!isset($_POST["username"]) || $_POST["username"] == "") {
		    $this->my_smarty->assign("username_class","red_border");
		    $missing_field = true;
		}
		
		if(!isset($_POST["password"]) || $_POST["password"]=="") {
		    $this->my_smarty->assign("password_class","red_border");
		    $missing_field = true;
		}
	 	
	 	if($missing_field) {
	 		$this->showError($this->lang_error["missing_username_or_password"]);
	 		return false;
	 	}
	 	
	 	return true;
	 }
	 
   function getScriptName() {
   		global $php_extension;
   	    return "login.".$php_extension;
   }
 
 }
 
 $login_view = new LoginView();
 $login_view->display();
 
?>
