<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/*
 * Created on 25.04.2005
 * 
 * This script shows and checks the register dialogue.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('./classes/DisplayView.class.php');
 
 class RegisterView extends DisplayView {
 	
 	function RegisterView() {
 		parent::DisplayView();
 		$this->setTitle($this->lang_main["register_title"]);
 		
 		$username_act = $this->session_manager->getUsername();
 		$password_act = $this->session_manager->getUserpass();
 	}
 	
 	function display() {
 		if($this->options["registration_allowed"] == 0) {
			$this->showErrorPage($this->lang_error["registration_forbidden"]);
			exit;
		}
 		if($this->valid_user) {
 			$this->showErrorPage($this->lang_error["registration_logged_in_error"]);
 			exit;
 		}
 		if((isset($_POST["do"]) && $_POST["do"]=="register") && $this->checkInputfields()) {
 			if(!$this->user_manager->userExists($_POST["username"]) && $this->user_manager->addUser($_POST["username"],$_POST["firstname"],
		    $_POST["lastname"],$_POST["email"],$_POST["mobile"],$_POST["password"])) {
		    	$this->showSuccess($this->lang_main["registration_success"]);
		    	$this->my_smarty->display($this->options["template"].'/success.tpl');
		    	exit;
		    } else if($this->user_manager->userExists($_POST["username"]))
		      $this->showError($this->lang_error["user_exists"]);
		      else
		      $this->showError($this->lang_error["registration_failure"]);
		    	
		}
 		$this->showForm();
 		
 		$this->my_smarty->display($this->options["template"].'/register.tpl');
 	}
 	
 	function showForm() {
 		global $config;
 		
 		$this->my_smarty->assign('register_title',$this->lang_main["register_title"]);
		$this->my_smarty->assign('php_self', $this->createSelfURL());
		$this->my_smarty->assign('enter_data_message',$this->lang_main["enter_data_message"]);
		$this->my_smarty->assign('firstname_label',$this->lang_main["firstname_label"]);
		if(isset($_POST["firstname"]))
			$this->my_smarty->assign('firstname_value',$_POST["firstname"]);
		$this->my_smarty->assign('lastname_label',$this->lang_main["lastname_label"]);
		if(isset($_POST["lastname"]))
			$this->my_smarty->assign('lastname_value',$_POST["lastname"]);
		$this->my_smarty->assign('email_label',$this->lang_main["email_label"]);
		if(isset($_POST["email"]))
			$this->my_smarty->assign('email_value',$_POST["email"]);
		$this->my_smarty->assign('mobile_label',$this->lang_main["mobile_label"]);
		if(isset($_POST["mobile"]))
			$this->my_smarty->assign('mobile_value',$_POST["mobile"]);
		$this->my_smarty->assign('username_label',$this->lang_main["username_label"]);
		if(isset($_POST["username"]))
			$this->my_smarty->assign('username_value',$_POST["username"]);
		$this->my_smarty->assign('password_label',$this->lang_main["password_label"]);
		$this->my_smarty->assign('password_confirm_label',$this->lang_main["password_confirm_label"]);
	    $this->my_smarty->assign('register_button',$this->lang_main["register_button"]);
 	}
 	
 	function checkInputfields() {
	 	$missing_field = false;
	 	$req_fields = array(0 => 'firstname',1 => 'lastname',2 => 'email',3 => 'username',4 => 'password',5 => 'pwconfirm');
	 	
	 	foreach($req_fields as $field) {
	 		if(!isset($_POST[$field]) || $_POST[$field]=="") {
	 		    $this->my_smarty->assign($field."_class","red_border");
	 		    $missing_field = true;
	 		}
	 	}
	 	
	 	if($missing_field) {
	 		$this->showError($this->lang_error["missing_input_fields"]);
	 		return false;
	 	}
	 	
	 	if($_POST["password"] != $_POST["pwconfirm"]) {
	 		$this->my_smarty->assign("password_class","red_border");
	 		$this->my_smarty->assign("pwconfirm_class","red_border");
	 		$this->showError($this->lang_error["password_missmatch_error"]);
	 		return false;
	 	}
	 	return true;
	}
	
	function getScriptName() {
		global $php_extension;
   	    return "register.".$php_extension;
    }
 }
 
 $register_view = new RegisterView();
 $register_view->display();
 
?>
