<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/*
 * Created on 25.04.2005
 *
 * This script shows and checks the register dialogue.
 *
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */

 require_once('./classes/DisplayView.class.php');

 class SendMailView extends DisplayView {

 	function SendMailView() {
 		parent::DisplayView();
 		$this->setTitle($this->lang_main["send_mail_title"]);
 	}

 	function display() {
 		if(!$this->valid_user) {
 			$this->showErrorPage($this->lang_error["sendmail_not_loggedin"]);

 			exit;
 		}

 		if(isset($_POST["do"]) && $_POST["do"] == "sendmail"){
	 		if(isset($_POST["authorID"]) && $_POST["authorID"] != "" && $this->checkInputfields()) {
	 			if($send = $this->user_manager->sendMailToUser($_POST["authorID"], $this->session_manager->getUsername(), $_POST["subject"], $_POST["message"])){
			    	$this->showSuccess($this->lang_main["sendmail_success"]);
			    	$this->my_smarty->display($this->options["template"].'/success.tpl');
			    	exit;
			    }
			    else $this->showError($this->lang_error["sendmail_failure"]);
	 		}
	 		else if(isset($_POST["commentID"]) && $_POST["commentID"] != "" && $this->checkInputfields()) {
	 			if($send = $this->user_manager->sendMailToUserGuest($this->comment_manager->getCommentAuthorEmail($_POST["commentID"]), $this->user_manager->getUsername(), $_POST["subject"], $_POST["message"])){
			    	$this->showSuccess($this->lang_main["sendmail_success"]);
			    	$this->my_smarty->display($this->options["template"].'/success.tpl');
			    	exit;
			    }
			    else $this->showError($this->lang_error["sendmail_failure"]);
	 		}
 		}
		$this->showForm();

 		$this->my_smarty->display($this->options["template"].'/sendmail.tpl');
 	}

 	function showForm() {
 		global $config;

 		$this->my_smarty->assign('send_mail_title',$this->lang_main["send_mail_title"]);
		//$this->my_smarty->assign('back_url', base64_decode($_GET["b"]));
		$this->my_smarty->assign('enter_data_message',$this->lang_main["enter_data_message"]);
		if(isset($_GET["authorID"]) && $_GET["authorID"] != "")
			$this->my_smarty->assign('authorID',$_GET["authorID"]);
		else if(isset($_GET["commentID"]) && $_GET["commentID"] != "")
			$this->my_smarty->assign('commentID',$_GET["commentID"]);

		$this->my_smarty->assign('subject_label',$this->lang_main["subject_label"]);
		if(isset($_POST["subject"]))
			$this->my_smarty->assign('subject_value',$_POST["subject"]);

		$this->my_smarty->assign('message_label',$this->lang_main["message_label"]);
		if(isset($_POST["message"]))
			$this->my_smarty->assign('message_value',$_POST["message"]);

		$this->my_smarty->assign('send_button',$this->lang_main["send_button"]);
 	}

 	function checkInputfields() {
	 	$missing_field = false;
	 	$req_fields = array(0 => 'subject',1 => 'message');

	 	foreach($req_fields as $field) {
	 		if(!isset($_POST[$field]) || $_POST[$field]=="") {
	 		    $this->my_smarty->assign($field."_class","red_border");
	 		    $missing_field = true;
	 		}
	 	}
	 	if($missing_field) {
	 		$this->showError($this->lang_error["missing_input_fields"]);
	 		return false;
	 	}
	}

	function getScriptName() {
		global $php_extension;
   	    return "sendmail.".$php_extension;
    }
 }

 $send_mail = new SendMailView();
 $send_mail->display();

?>
