<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on 26.08.2005
 *
 * This class shows the statistics of an item.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once('./classes/ViewManager.class.php');
 require_once('./classes/DisplayView.class.php');
 
 class StatisticView extends DisplayView {
 	
 	var $view_manager;
 	var $item_data;
 	
 	function StatisticView() {
 		global $config;
 		parent::DisplayView();
 		$this->view_manager = new ViewManager($this->dbCon,$config);
 	}
 	
 	function display() {
 		$this->item_data = $this->getItem();
 		if(!$this->item_data) return;
 		
 		$this->my_smarty->assign('statistic_title',$this->lang_main["statistic_title"]);
 		$this->my_smarty->assign('title',$this->lang_main["statistic_title"]." \"".$this->item_data["title"]."\"");
 		$this->my_smarty->assign('item_title',"\"".$this->item_data["title"]."\"");
 		$this->showStatistic();
 		$this->my_smarty->display($this->options["template"].'/statistic.tpl');
 	}
 	
 	/**
 	 * Shows a statistic for this item.
 	 */
 	function showStatistic() {
 		
 		$this->my_smarty->assign('visitor_label',$this->lang_main["statistic_visitor"]);
 		$this->my_smarty->assign('user_label',$this->lang_main["statistic_user"]);
 		
 		$time = time();
 		$day = date("d",$time);
		$month = date("m",$time);
		$year = date("Y",$time);
 		$day_stat = $this->view_manager->getViewsPerDay($this->item_data["itemID"],$day,$month,$year);
 		$this->my_smarty->assign('today_label',$this->lang_main["today"]);
 		$this->my_smarty->assign('day_count',$day_stat);
 		$month_stat = $this->view_manager->getViewsPerMonth($this->item_data["itemID"],$month,$year);
 		$this->my_smarty->assign('month_label',$this->lang_main["month"]);
 		$this->my_smarty->assign('month_count',$month_stat);
 		$year_stat = $this->view_manager->getViewsPerYear($this->item_data["itemID"],$year);
 		$this->my_smarty->assign('year_label',$this->lang_main["year"]);
 		$this->my_smarty->assign('year_count',$year_stat);
 		
 		$days = $this->view_manager->getDaysOfMonth($this->item_data["itemID"],$month,$year);
 		$this->my_smarty->assign('days',$days);
 		$days_for_month = cal_days_in_month(CAL_GREGORIAN, $month, $year);
 		$this->my_smarty->assign('days_count',$days_for_month+1);
 		$most_views = $this->view_manager->getMaxOfMonth($this->item_data["itemID"],$month,$year);
 		$this->my_smarty->assign('most_views',$most_views);
 	}
 	
 	function getItem() {
 		$item_data = false;
 		if(!isset($_REQUEST["itemID"]) || !$item_data = $this->item_manager->getItemByID($_REQUEST["itemID"])) {
		 	$this->setTitle($this->lang_error["error_title"]);
		 	
		 	$this->my_smarty->assign('error_title',$this->lang_error["item_not_existing_title"]); 
		    $this->my_smarty->assign('error_message',$this->lang_error["item_not_existing"]);
		    $this->my_smarty->display($this->options["template"].'/error.tpl');
		 	return false;
		}
		if(preg_match("/l/", $this->options["date_format"])){
			$item_data["item_date"] = $this->item_manager->getDateString($this->options["date_format"], $item_data["item_timestamp"], $this->lang_main);
		}
		else $item_data["item_date"] = date($this->options["date_format"], $item_date["item_timestamp"]);
		return $item_data;
 	}
	
	function getScriptName() {
		global $php_extension;
   	    return "statistic.".$php_extension;
    }
 }
 
 $statistic_view = new StatisticView();
 $statistic_view->display();
 
?>