<?php
/********************************************************************************
* Copyright (C) 2005 Alexander De Luca, Michael Mller

* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*********************************************************************************/

/**
 * Created on Apr 6, 2005
 * 
 * This script receives post submissions and analyses if it contains an item, 
 * media_data or anything else.
 * 
 * @author Alexander De Luca, Michael Mueller
 * @version 0.1
 */
 
 require_once("config.php");
 require_once($config["proj_path"]."/classes/Response.class.php");
 require_once($config["proj_path"]."/classes/DBConManager.class.php");
 require_once($config["proj_path"]."/classes/ItemParser.class.php");
 require_once($config["proj_path"]."/classes/UserManager.class.php");
 require_once($config["proj_path"]."/classes/RankManager.class.php");
 require_once($config["proj_path"].'/classes/ThumbCreator.class.php');
 require_once($config["proj_path"].'/classes/ItemManager.class.php');
 
 
 $dbCon = new DBConManager($config);
 $user_manager = new UserManager($dbCon, $config);
 $rank_manager = new RankManager($dbCon, $config);
 $response = new Response();
 $options = $dbCon->getOptionsArray();
 
 require_once("./language/".$options["language"]."/lang_error.php");
 
//$file = fopen("log.txt","a");
//print_r($_POST);
// print_r($_ENV);
// print_r($_SERVER);
//print_r($_FILES);

// fputs($file, "dateizugriff\n");
 $item_parser = new ItemParser($dbCon, $config);
 if (isset($_POST["do"])){
 		
 	if($_POST["do"] == "newitem") {
 		//check if all post variables are set
	 	if (!isset($_POST["username"]) || !isset($_POST["password"]) || !isset($_POST["title"])
	 	    || !isset($_POST["item_text"])){
	 		$response->sendError($lang_error["missing_post_variables_newitem"]);
	 	}
	 	
	 	if (!$user_manager->isValidUser($_POST["username"], $_POST["password"]))
	 		$response->sendError($lang_error["wrong_username_or_password"]);
	 	$user = $user_manager->getUser($user_manager->getUserIDByUsername($_POST["username"]));
	 	if(!$rank_manager->addItemAllowed($user))
	 		$response->sendError($lang_error["add_item_forbidden"]);
	 	
	 	
	 	$item_data = array();
	 	$item_data["user"] = $_POST["username"];
	 	$item_data["title"] = $_POST["title"];
	 	$item_data["item_text"] = $_POST["item_text"];
	 	if (isset($_POST["location"])) $item_data["location"] = $_POST["location"];
	 	if (isset($_POST["category"])) $item_data["category"] = $_POST["category"];
	 	if (isset($_POST["time_needed"])) $item_data["time_needed"] = $_POST["time_needed"];
	 	
	 	$item_data["item_editor"] = MIDLET_EDITOR;
	 	
	 	if (isset($_POST["invisible"]))
	 	   $itemID = $item_parser->parseItem($item_data,0);
	 	else
	 	   $itemID = $item_parser->parseItem($item_data);
	 	
	 	foreach($_FILES as $file) {
	 		$media_data = array(0 => array("name"=>$file["name"],"tmp_name"=>$file["tmp_name"]));
	 		$item_parser->addMedia($itemID, $media_data);
	 	}
//	 	fputs($file, mysql_error());
//	 	fputs($file, "post erfolgreich: itemid = ".$itemID."\n");
	 	$response->sendMessage($itemID);
 	} else if($_POST["do"] == "addmedia") {
 		//$filedsf = fopen("log.txt","a");
 		if (!isset($_POST["username"]) || !isset($_POST["password"]) || !isset($_POST["itemid"])) {
	 		$response->sendError($lang_error["missing_post_variables_addmedia"]);
	 	}
	 	
//	    fputs($file, "variable filename: ".$_SERVER["HTTP_FILENAME"]."\n");
	 	if (!$user_manager->isValidUser($_POST["username"], $_POST["password"])) $response->sendError($lang_error["wrong_username_or_password"]);
	 	$user = $user_manager->getUser($user_manager->getUserIDByUsername($_POST["username"]));
	 	if(!$rank_manager->addItemAllowed($user))
	 		$response->sendError($lang_error["add_item_forbidden"]);
	 	
	 	$itemID = $_POST["itemid"];
	 	
//	 	print_r($_FILES);
        
        foreach($_FILES as $file) {
        	//echo $file["name"];
	 		$media_data = array(0 => array("name"=>$file["name"],"tmp_name"=>$file["tmp_name"]));
	 		$item_parser->addMedia($itemID, $media_data);
	 	}
	 	
	 	if(isset($_POST["lastItem"]) && $_POST["lastItem"] == "true")
	 		$item_manager = new ItemManager($dbCon, $config,$dbCon->getOptionsArray());
	 		$item_manager->setVisible($_POST["itemid"],true);
//print_r($_FILES);
 	}  else if($_POST["do"] == "set_visible") {
 		if (!isset($_POST["username"]) || !isset($_POST["password"]) || !isset($_POST["itemid"])){
	 		$response->sendError($lang_error["missing_post_variables_newitem"]);
	 	}
	 	
	 	if (!$user_manager->isValidUser($_POST["username"], $_POST["password"])) $response->sendError($lang_error["wrong_username_or_password"]);
	 	$user = $user_manager->getUser($user_manager->getUserIDByUsername($_POST["username"]));
	 	if(!$rank_manager->addItemAllowed($user))
	 		$response->sendError($lang_error["add_item_forbidden"]);
	 	
	 	$item_manager = new ItemManager($dbCon, $config,$dbCon->getOptionsArray());
	 	$item_manager->setVisible($_POST["itemid"],true);
 	}
 	
 } else {
 	$response->sendError($lang_error["missing_do_variable"]);
 }

?>
